#define MAME

#ifdef MAME

  #include "mamalleg.h"
  #include "driver.h"

#else

  #include <allegro.h>

  static void logerror(char* txt, ...)
  {


  }

#endif





#include <pc.h>
#include <conio.h>
#include <sys/farptr.h>
#include <go32.h>
#include <time.h>
#include <math.h>
#include <dpmi.h>
#include "s6326_15.h"
#include "mode15k.h"



#define SiS6326    1
#define SiS620	   2
#define SiS530	   3
#define SiS300	   4
#define SiS630	   5
#define SiS540	   6



static void SetSiS6326ExtRegister(CRTCPARAM *cp);
static int	GetSiS6326BytePerLine(void);
static void SetSiS6326BytePerLine(int d0);
static void SetSiS6326Interlace(int flag);
static int	SetSiS6326VClock(BYTE Numerator, BYTE Divider,
							 BYTE DeNumerator, BYTE PostScalar,
							 BYTE SeqDivider);

static void SetSiS300ExtRegister(CRTCPARAM *cp);
static int	GetSiS300BytePerLine(void);
static void SetSiS300BytePerLine(int d0);
static void SetSiS300Interlace(int flag);
static int	SetSiS300VClock(BYTE Numerator, BYTE Divider,
							BYTE DeNumerator, BYTE PostScalar,
							BYTE SeqDivider);

static void SetDoubleScan(int flag);
static void SetClockRegisterInternal(void);
static BOOL SiSExtRegisterUnLock(void);

static long GetVclkParam(long vclk, int *Num, int *DeN,
									int *Div, int *PS, int *SeqDiv);

static DWORD DeviceType = 0;



int detectSiS6326(void)
{
//
//	DPMI & PCI BIOS calling from ifsega2p.c. Thanks to SUZ.
//
	__dpmi_regs 	r;

	r.d.eax = 0x0000b101;						// PCI BIOS - INSTALLATION CHECK
	r.d.edi = 0x00000000;
	__dpmi_int(0x1a, &r);
	if( r.d.edx != 0x20494350 ){				// ' ICP'
		logerror("PCI BIOS not Installed.\n");
		return 0;
	}

	while(1){
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000620;						// device ID
		r.d.edx = 0x00001039;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("SiS620 found\n");
			DeviceType = SiS620;
			break;
		}
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000530;						// device ID
		r.d.edx = 0x00001039;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("SiS530 found\n");
			DeviceType = SiS530;
			break;
		}
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00006326;						// device ID
		r.d.edx = 0x00001039;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("SiS6326 found\n");
			DeviceType = SiS6326;
			break;
		}
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000300;						// device ID
		r.d.edx = 0x00001039;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			logerror("SiS300 found\n");
			DeviceType = SiS300;
			break;
		}
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000630;						// device ID
		r.d.edx = 0x00001039;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			printf("SiS630 found\n");
			DeviceType = SiS630;
			break;
		}
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000540;						// device ID
		r.d.edx = 0x00001039;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ){
			printf("SiS540 found\n");
			DeviceType = SiS540;
			break;
		}

		logerror("sis: SiS not found\n");
		return 0;
	}


	if(SiSExtRegisterUnLock() == FALSE){
		logerror("15.75KHz: Failed unlock extention registers\n");
		return 0;
	}

#ifdef MAME
	DisableStretch();
#endif

	return 1;
}





static BOOL SiSExtRegisterUnLock(void)
{
	BYTE d0;

	d0 = GetSeqReg(0x05);
	if(d0 == 0xA1)
		return TRUE;
	SetSeqReg(0x05, 0x86);
	if(GetSeqReg(0x05) == 0xA1){
		logerror("15.75KHz: SiS extention registers unlocked\n");
		return TRUE;
	}
	SetSeqReg(0x05, d0);

	return FALSE;
}


void resetSiS6326_15KHz(void)
{
}



int setSiS6326(void)
{
	CRTCPARAM cp;
	int Num;
	int DeN;
	int Div;
	int PS;
	int SeqDiv;

	if(GetMode15KHz(&cp) == 0) return 0;
	cp.dotclockHz = GetVclkParam(cp.dotclockHz, &Num, &Div, &DeN, &PS, &SeqDiv);
	cp.vert001Hz = CalcVert001Hz(cp.dotclockHz, cp.HTotal, cp.VTotal, cp.interlace);
	cp.horzHz = CalcHorizontalHz(cp.dotclockHz, cp.HTotal);
	cp.HBStart = cp.HDisp;
	cp.HBEnd   = cp.HTotal - 8;
	cp.VBStart = cp.VDisp;
	cp.VBEnd   = cp.VTotal - 1;

	DispCrtcParam(&cp);

	DisableGenerateSignal();
	switch(DeviceType){
		case SiS6326:
		case SiS620:
		case SiS530:
			SetSiS6326VClock(Num, Div, DeN, PS, SeqDiv);
			SetGenericVGARegister(&cp);
			SetSiS6326ExtRegister(&cp);
			SetDoubleScan(cp.doublescan);
			SetSiS6326Interlace(cp.interlace);
			SetHVPolarity(cp.hpolarity, cp.vpolarity);
			break;

		case SiS300:
		case SiS630:
		case SiS540:
			SetSiS300VClock(Num, Div, DeN, PS, SeqDiv);
			SetGenericVGARegister(&cp);
			SetSiS300ExtRegister(&cp);
			SetDoubleScan(cp.doublescan);
			SetSiS300Interlace(cp.interlace);
			SetHVPolarity(cp.hpolarity, cp.vpolarity);
			break;
	}
	EnableGenerateSignal();

	RegCRTCPARAM(&cp);

	return 1;
}

int setSiS6326_15KHz(int vdouble, int width, int height)
{
	return setSiS6326();
}


void centerSiS6326_15KHz(int dx, int dy)
{
	CRTCPARAM cp;


	switch(DeviceType){
		case SiS6326:
		case SiS620:
		case SiS530:
			GetCRTCPARAM(&cp);
			Centering(&cp, dx, dy);
			RegCRTCPARAM(&cp);
			SetGenericVGARegister(&cp);
			SetSiS6326ExtRegister(&cp);
			break;

		case SiS300:
		case SiS630:
		case SiS540:
			GetCRTCPARAM(&cp);
			Centering(&cp, dx*8, dy);
			RegCRTCPARAM(&cp);
			SetGenericVGARegister(&cp);
			SetSiS300ExtRegister(&cp);
			break;
	}
}






static void SetClockRegisterInternal(void)
{
	BYTE d0;

	d0 = _in(0x3CC);
	d0 = d0 | 0x0C;
	_out(0x3C2, d0);
}


static BYTE PostScalarTable[]={ 0, 0x00, 0x01, 0x02, 0x03, 0, 0x02, 0, 0x03};

static int SetSiS6326VClock(BYTE Numerator, BYTE Divider,
							BYTE DeNumerator, BYTE PostScalar,
							BYTE SeqDivider)
{
	BYTE _2B_DeN;
	BYTE _2B_PS;
	BYTE _2A_Div;
	BYTE _2A_Num;
	BYTE _13_PS;
	BYTE d0;
	int d1;

	SetClockRegisterInternal();
	SetSeqReg(0x38, GetSeqReg(0x38) & 0xFC);

	d0 = 0x01;
	if(SeqDivider == 2)  d0 = d0 | 0x08;
	SetSeqReg(0x01, d0);

	_2A_Div = ((Divider == 1) ? 0 : 1) << 7;
	_2A_Num = (Numerator - 1) & 0x7F;
	_13_PS	= ((PostScalar == 6 || PostScalar == 8) ? 1 : 0) << 6;
	_2B_PS	= PostScalarTable[PostScalar] << 5;
	_2B_DeN = (DeNumerator - 1) & 0x1F;

	d0 = _2A_Div | _2A_Num;
	SetSeqReg(0x2A, d0);
	d0 = GetSeqReg(0x13);
	d0 = d0 & ~0x40;
	d0 = d0 | _13_PS;
	SetSeqReg(0x13, d0);
	d0 = _2B_PS | _2B_DeN;
//	if( frequency >= high ) d0 |= 0x80;
	SetSeqReg(0x2B, d0);			   // trigger ?

	d1 = 65536;
	while(d1 > 0){
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		d1 -= 1;
	}

	return 0;
}


static int SetSiS300VClock(BYTE Numerator, BYTE Divider,
							BYTE DeNumerator, BYTE PostScalar,
							BYTE SeqDivider)
{
	BYTE d0;
	int d1;
	BYTE xr2b;
	BYTE xr2c;
	int sbit;

	SetClockRegisterInternal();

	d0 = 0x01;
	if(SeqDivider == 2)  d0 = d0 | 0x08;
	SetSeqReg(0x01, d0);

	sbit = (PostScalar == 6 || PostScalar == 8) ? 1 : 0;
	PostScalar = PostScalarTable[PostScalar];

	xr2b = (Numerator - 1) & 0x7f;
	if (Divider == 2)
		xr2b |= 0x80;
	xr2c = (DeNumerator - 1) & 0x1f;
	xr2c |= PostScalar << 5;
	if (sbit)
		xr2c |= 0x80;
	SetSeqReg(0x2B, xr2b);
	SetSeqReg(0x2C, xr2c);
	SetSeqReg(0x2D, 0x80);

	d1 = 65536;
	while(d1 > 0){
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		inportb(0x3da);
		d1 -= 1;
	}

	return 0;
}




void SetSiS6326ExtRegister(CRTCPARAM *cp)
{
	int d0;

	d0 = GetSeqReg(0x0A);
	d0 = BitMov(d0, 0, cp->VTotal  - 2,  10);
	d0 = BitMov(d0, 1, cp->VDisp   - 1 , 10);
	d0 = BitMov(d0, 2, cp->VBStart	   , 10);
	d0 = BitMov(d0, 3, cp->VSStart	   , 10);
	SetSeqReg(0x0A, d0);


	d0 = BitMov(d0, 0, (cp->HTotal	>> 3) - 5,	8);
	d0 = BitMov(d0, 1, (cp->HDisp	>> 3) - 1,	8);
	d0 = BitMov(d0, 2, (cp->HBStart >> 3)	 ,	8);
	d0 = BitMov(d0, 3, (cp->HSStart >> 3)	 ,	8);
	d0 = BitMov(d0, 4, (cp->HBEnd	>> 3)	 ,	6);
#if 1
	d0 = BitMov(d0, 5, cp->HSStart, 0);
	d0 = BitMov(d0, 6, cp->HSStart, 1);
	d0 = BitMov(d0, 7, cp->HSStart, 2);
#else
	d0 = d0 & 0x1F;
#endif
	SetSeqReg(0x12, d0);


}



void SetSiS300ExtRegister(CRTCPARAM *cp)
{
	int d0;

	d0 = (
		(((cp->VSEnd)	 & 0x10 ) <<  1) |		 /* D5 */
		(((cp->VBEnd)	 & 0x100) >>  4) |		 /* D4 */
		(((cp->VSStart)  & 0x400) >>  7) |		 /* D3 */
		(((cp->VBStart)  & 0x400) >>  8) |		 /* D2 */
		(((cp->VDisp-1)  & 0x400) >>  9) |		 /* D1 */
		(((cp->VTotal-2) & 0x400) >> 10));		 /* D0 */
	SetSeqReg(0x0A, d0);

	d0 = (
		(( (cp->HSStart >> 3)	   & 0x300) >> 2)  |  /* D76 */
		(( (cp->HBStart >> 3)	   & 0x300) >> 4)  |  /* D54 */
		((((cp->HDisp	>> 3) - 1) & 0x300) >> 6)  |  /* D32 */
		((((cp->HTotal	>> 3) - 5) & 0x300) >> 8));   /* D10 */
	SetSeqReg(0x0B, d0);

	d0	= GetSeqReg(0x0C) & 0xF8;
	d0 |= (((cp->HSEnd >> 3) & 0x20) >> 3) |	  /* D2 */
		  (((cp->HBEnd >> 3) & 0xC0) >> 6); 	  /* D10 */
	SetSeqReg(0x0C, d0);
}






static int GetSiS6326BytePerLine(void)
{
	DWORD d0;

	d0	= (DWORD)GetCrtcReg(0x13);
	d0 |= (DWORD)((GetSeqReg(0x0A) << 4) & 0x0F00);
	d0 = d0 << 3;
	return d0;
}

static void SetSiS6326BytePerLine(int d0)
{
	BYTE d1;

	d0 = d0 >> 3;
	d1 = (BYTE)(d0 & 0xFF);
	SetCrtcReg(0x13, d1);
	d1 = GetSeqReg(0x0A) & 0x0F;
	d1 = d1 | (BYTE)((d0 >> 4) & 0xF0);
	SetSeqReg(0x0A, d1);
}


static void SetDoubleScan(int flag)
{
	if(flag == 0){
		SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 0, 0));
	}else{
		SetCrtcReg(0x09, BitMov(GetCrtcReg(0x09), 7, 1, 0));
	}
}


static void SetSiS6326Interlace(int flag)
{
	BYTE d1;

	if(flag == 0){
		d1 = GetSeqReg(0x06);
		if( (d1 & (1 << 5)) != 0){
			d1 = d1 & ~(1 << 5);					// Interlace Disable
			SetSeqReg(0x06, d1);
			SetSiS6326BytePerLine( GetSiS6326BytePerLine() / 2);
		}
	}else{
		d1 = GetSeqReg(0x06);
		if( (d1 & (1 << 5)) == 0){
			d1 = d1 | (1 << 5); 					// Interlace Enable
			SetSeqReg(0x06, d1);
			SetSiS6326BytePerLine( GetSiS6326BytePerLine() * 2);
		}
	}
}


static int GetSiS300BytePerLine(void)
{
	DWORD d0;

	d0	= (DWORD)GetCrtcReg(0x13) & 0xFF;
	d0 |= (DWORD)(GetSeqReg(0x0E) << 8) & 0x0F00;
	d0 = d0 << 3;
	return d0;
}

static void SetSiS300BytePerLine(int d0)
{
	BYTE d1;

	d0 = d0 >> 3;
	d1 = (BYTE)(d0 & 0xFF);
	SetCrtcReg(0x13, d1);
	d1 = GetSeqReg(0x0E) & 0xF0;
	d1 = d1 | ((d0 >> 8) & 0x0F);
	SetSeqReg(0x0E, d1);
}


static void SetSiS300Interlace(int flag)
{
	BYTE d1;

	if(flag == 0){
		d1 = GetSeqReg(0x06);
		if( (d1 & (1 << 5)) != 0){
			d1 = d1 & ~(1 << 5);					// Interlace Disable
			SetSeqReg(0x06, d1);
			SetSiS300BytePerLine( GetSiS300BytePerLine() / 2);
		}
	}else{
		d1 = GetSeqReg(0x06);
		if( (d1 & (1 << 5)) == 0){
			d1 = d1 | (1 << 5); 					// Interlace Enable
			SetSeqReg(0x06, d1);
			SetSiS300BytePerLine( GetSiS300BytePerLine() * 2);
		}
	}
}

#if 1

#define MAX_VCO 135000000
#define BASE_FREQ 14318000

static long GetVclkParam(long vclk, int *Num, int *Div,
							int *DeN, int *PS, int *SeqDiv)
{
	double desfreq;
	double temp;
	double tempdt;
	double dt;
	int d0;
	int d1;
	int P[2];
	int PD = 0;
	int idx;

	if(vclk > 135000000) vclk = 135000000;

	P[0] = 1;
	P[1] = 1;
	if(vclk < (BASE_FREQ * 6) / 2){
		P[0] = 2;
		P[1] = 3;
	}
	if(vclk < (BASE_FREQ * 6) / 3){
		P[0] = 3;
		P[1] = 4;
	}
	if(vclk < (BASE_FREQ * 6) / 4){
		P[0] = 4;
		P[1] = 6;
	}
	if(vclk < (BASE_FREQ * 6) / 6){
		P[0] = 6;
		P[1] = 8;
	}
	if(vclk < (BASE_FREQ * 6) / 8){
		P[0] = 8;
		P[1] = 12;
	}
	if(vclk < (BASE_FREQ * 6) / 12){
		P[0] = 12;
		P[1] = 16;
	}
	if(vclk < (BASE_FREQ * 6) / 16){
		P[0] = 16;
		P[1] = 16;
	}

	*Num = 0;
	*DeN = 0;
	dt = MAX_VCO;
	idx = 0;
	while(idx < 2){
		desfreq = vclk;
		for(d0 = 2; d0 <= 128*2; d0 += 1){
			if((128 <= d0) && (d0 % 2 == 1))
				continue;
			for(d1 = 3; d1 <= 32; d1 += 1){
				temp = BASE_FREQ * (double)d0 / d1;
				if(temp > MAX_VCO)
					continue;
				temp = temp / P[idx];
				if(desfreq > temp)
					tempdt = desfreq - temp;
				else
					tempdt = temp - desfreq;
				if(tempdt < dt){
					*Num = d0;
					*DeN = d1;
					dt = tempdt;
					PD = P[idx];
				}
			}
		}
		idx += 1;
	}

	if(*Num > 128){
		*Div  = 2;
		*Num /= 2;
	}else{
		*Div  = 1;
	}

	if(PD <= 8){
		*SeqDiv = 1;
		*PS = PD;
	}else{
		*SeqDiv = 2;
		*PS = PD / 2;
	}


	vclk = (long)((double)BASE_FREQ * (*Num * *Div)/(*DeN * *PS * *SeqDiv));

	logerror("Num %3d, DeN %3d, Div %1d, PS %1d, SeqDiv %1d\n",
				*Num, *DeN, *Div, *PS, *SeqDiv);
	logerror("14.318 * (Num/DeN) : %lf\n", (BASE_FREQ/1000000)*(*Num)/(*DeN));
	logerror("vclk : %lf\n", (double)vclk / 1000000.0);

	return vclk;
}


#else





//#define MAX_VCO 353000000
#define MAX_VCO 135000000
#define BASE_FREQ 14318000

static long GetVclkParam(long vclk, int *Num, int *Div,
							int *DeN, int *PS, int *SeqDiv)
{
	double desfreq;
	double temp;
	double tempdt;
	double dt;
	int d0;
	int d1;
	int P[2];
	int PD = 0;
	int idx;

	if(vclk > 135000000) vclk = 135000000;

	P[0] = 1;
	P[1] = 1;
	if(vclk < (BASE_FREQ * 6) / 2){
		P[0] = 2;
		P[1] = 3;
	}
	if(vclk < (BASE_FREQ * 6) / 3){
		P[0] = 3;
		P[1] = 4;
	}
	if(vclk < (BASE_FREQ * 6) / 4){
		P[0] = 4;
		P[1] = 6;
	}
	if(vclk < (BASE_FREQ * 6) / 6){
		P[0] = 6;
		P[1] = 8;
	}
	if(vclk < (BASE_FREQ * 6) / 8){
		P[0] = 8;
		P[1] = 12;
	}
	if(vclk < (BASE_FREQ * 6) / 12){
		P[0] = 12;
		P[1] = 16;
	}
	if(vclk < (BASE_FREQ * 6) / 16){
		P[0] = 16;
		P[1] = 16;
	}

	*Num = 0;
	*DeN = 0;
	dt = MAX_VCO;
	idx = 0;
	while(idx < 2){
		desfreq = vclk;
		for(d0 = 2; d0 <= 128*2; d0 += 1){
			if((128 <= d0) && (d0 % 2 == 1))
				continue;
			for(d1 = 3; d1 <= 32; d1 += 1){
				temp = BASE_FREQ * (double)d0 / d1;
				if(temp > MAX_VCO)
					continue;
				temp = temp / P[idx];
				if(desfreq > temp)
					tempdt = desfreq - temp;
				else
					tempdt = temp - desfreq;
				if(tempdt < dt){
					*Num = d0;
					*DeN = d1;
					dt = tempdt;
					PD = P[idx];
				}
			}
		}
		idx += 1;
	}

	if(*Num > 128){
		*Div  = 2;
		*Num /= 2;
	}else{
		*Div  = 1;
	}

	if(PD <= 8){
		*SeqDiv = 1;
		*PS = PD;
	}else{
		*SeqDiv = 2;
		*PS = PD / 2;
	}


	vclk = (long)((double)BASE_FREQ * (*Num * *Div)/(*DeN * *PS * *SeqDiv));

	logerror("Num %3d, DeN %3d, Div %1d, PS %1d, SeqDiv %1d\n",
				*Num, *DeN, *Div, *PS, *SeqDiv);
	logerror("14.318 * (Num/DeN) : %lf\n", (BASE_FREQ/1000000)*(*Num)/(*DeN));
	logerror("vclk : %lf\n", (double)vclk / 1000000.0);

	return vclk;
}


#endif
