#define MAME

#include <stdio.h>
#include <stdlib.h>
#include <go32.h>
#include <dpmi.h>
#include <time.h>
#include <string.h>
#include <math.h>
#include <sys/farptr.h>
#include <pc.h>
#include <ctype.h>
#include "wss.h"

#ifdef MAME

#include "ticker.h"
//extern FILE *errorlog;

#endif




/***********************  TICKER  *************************/

#ifndef MAME

typedef uclock_t TICKER;

static TICKER ticker(void)
{
	return uclock();
}

#define TICKS_PER_SEC UCLOCKS_PER_SEC

#endif

/***********************  COMMON  *************************/


static int _dma_allocate_mem(int *sel, unsigned long *phys);
static void _dma_start(int channel, unsigned long addr, int size, int auto_init, int input);
static void _dma_stop(int channel);
static DWORD _dma_todo(int channel);
static int _dma_count;


static DWORD _dma_counter(void);
static int __dma_allocate_mem(int flag);
static int	 g_dmacnt_shift_count;


#define _8BITMONO		1
#define _8BITSTEREO 	2
#define _16BITSTEREO	3

static int pcm_format = _16BITSTEREO;

#define SAMPLECNT	  16384
#define SAMPLECNTMASK 0x3FFF


static int g_port = -1;
static int g_irq  = -1;
static int g_dma  = -1;
static int g_hdma = -1;

static int g_dma_buff_size;
static int g_wss_dma_sel = NULL;
static unsigned long g_wss_dma_addr = NULL;

static DWORD g_device_sample_rate = 0;

static char *device_name = "\n";
static char *error_mes = "\n";

static long _8bitconvert_max =	32767;
static long _8bitconvert_min = -32768;
static long _8bitconvert_sign = 0x8000;
static int	_8bitconvert_shiftcount = 8;
static _go32_dpmi_seginfo old_handler, new_handler;
static int old_handler_irq_vector = -1;

static int tick = 0;



static TICKER es_tick_per_hz = 0;
static TICKER es_remain = 0;
static TICKER es_prev = 0;
static DWORD  es_count;

static int eternal_silence_start(int rate_no);
static void eternal_silence_exit(void);
static DWORD eternal_silence_current_pos(void);
static char device_name_eternal_silence[] = "Eternal Silence";
static DWORD actual_sample_rate = 0;


#define DMACTYPE_NORMAL 			0
#define DMACTYPE_SILENCE			1
#define DMACTYPE_GF1				2
#define DMACTYPE_CMI8x38			3
#define DMACTYPE_EV1935 			4
#define DMACTYPE_4DWAVE 			5
#define DMACTYPE_SB201IRQ			6
#define DMACTYPE_SB100IRQ			7

static int DMACTYPE = DMACTYPE_NORMAL;


#define DEVICE_NONE 			-1
#define DEVICE_SILENCE			0
#define DEVICE_SB100			0x100
#define DEVICE_SB201			0x201
#define DEVICE_SBPRO			0x300
#define DEVICE_SB16 			0x400
#define DEVICE_GF1				5
#define DEVICE_WSS				6
#define DEVICE_ESS				7


static int DEVICE = DEVICE_NONE;


static char error_mes_wsscfg_not_found[]   = "WSSCFG not found.";
static char error_mes_blaster_not_found[]  = "BLASTER not found.";
static char error_mes_ultrasnd_not_found[] = "ULTRASND not found.";
static char error_mes_ultra16_not_found[]  = "ULTRA16 not found.";
static char error_mes_ev1935_not_found[]   = "EV1935 MachOne not found.";
static char error_mes_es1370_not_found[]   = "ES1370 not found.";
static char error_mes_cmi8x38_not_found[]  = "CMI8x38 not found.";
static char error_mes_trid4dwave_not_found[]	 = "Trident 4DWave not found.";
static char error_mes_ess_audiodrive_not_found[] = "ESS Audiodrive not found.";
static char error_mes_sndscape_not_found[]		 = "SNDSCAPE not found.";
static char error_mes_sndscape_ini_not_found[]	 = "SNDSCAPE.INI not found.";
static char error_mes_error_in_sndscape_ini[]	 = "error in SNDSCAPE.INI.";

static char error_mes_dma_allocate_mem_failed[] = "dma_allocate_mem failed.";
static char error_mes_sb_reset_dsp_failed[] 	= "sb_reset_dsp failed.";
static char error_mes_sb_read_dsp_ver_failed[]	= "sb_read_dsp_ver failed.";




static int stereo_reverse_flag = _FALSE;

/*	function  */

static DWORD get_played_sample_count(void);
static void calc_next_req(void);


/***********************  COMMON END  *********************/


/***********************  Window Sound System  ************/

static char device_name_windows_sound_system[] = "Windows Sound System";
static char device_name_soundscape[] = "Ensoniq Soundscape";
static char device_name_es1370[] = "ES1370 AudioPCI as Soundscape";
static char device_name_ev1935_as_wss[] = "EV1935 MachOne as WSS";
static char device_name_ev1935_as_sbpro[] = "EV1935 MachOne as SBPro";
static int soundscape_get_init_config(void);
static int detectES1370(void);
static int detectEV1935(void);
static DWORD audiopci_iobase = -1;
static DWORD ev1935_iobase = -1;

static int ev1935_as_sbpro_start(int rate_no);
static int ev1935_as_wss_start(int rate_no);

static int soundscape_start(int rate_no);
static int es1370_as_soundscape_start(int rate_no);

static int wss_irq_handler(void);
static void wss_wait(void);
static int wss_start(int rate_no);
static void wss_exit(void);






struct codec_rate_struct
{
   int freq;
   int divider;
};

static struct codec_rate_struct codec_rates[] =
{
   { 5512,	0x01 }, 	//	0
   { 6620,	0x0F }, 	//	1
   { 8000,	0x00 }, 	//	2
   { 9600,	0x0E }, 	//	3
   { 11025, 0x03 }, 	//	4
   { 16000, 0x02 }, 	//	5
   { 18900, 0x05 }, 	//	6
   { 22050, 0x07 }, 	//	7
   { 27420, 0x04 }, 	//	8
   { 32000, 0x06 }, 	//	9
   { 33075, 0x0D }, 	//	10
   { 37800, 0x09 }, 	//	11
   { 44100, 0x0B }, 	//	12
   { 48000, 0x0C }, 	//	13
   { 54857, 0x08 }, 	//	14
   { 64000, 0x0A }		//	15
};



/* CODEC ports */
#define IADDR	(g_port+4)
#define IDATA	(g_port+5)
#define STATUS	(g_port+6)
#define PIO 	(g_port+7)

#define INIT	0x80
#define MCE 	0x40
#define TRD 	0x20

#define INT 	0x01
#define PRDY	0x02
#define PLR 	0x04
#define PUL 	0x08
#define SER 	0x10
#define CRDY	0x20
#define CLR 	0x40
#define CUL 	0x80

#define LADC	0x00
#define RADC	0x01
#define LAUX1	0x02
#define RAUX1	0x03
#define LAUX2	0x04
#define RAUX2	0x05
#define LDAC	0x06
#define RDAC	0x07
#define FS		0x08
#define INTCON	0x09
#define PINCON	0x0A
#define ERRSTAT 0x0B
#define MODE_ID 0x0C
#define LOOPBCK 0x0D
#define PB_UCNT 0x0E
#define PB_LCNT 0x0F






/***********************  Window Sound System END  ********/


/***********************  BLASTER  ************************/

static char device_name_sb16[]		= "Sound Blaster 16";
static char device_name_sb16_ex[]	= "Sound Blaster 16 (ex_freq)";
static char device_name_sbpro[] 	= "Sound Blaster Pro";
static char device_name_sbpro_ex[]	= "Sound Blaster Pro (ex_freq)";
static char device_name_sbpro_irq[] = "Sound Blaster Pro (interrupt driven)";
static char device_name_sb201[] 	= "Sound Blaster 2.01";
static char device_name_sb201_irq[] = "Sound Blaster 2.01 (interrupt driven)";
static char device_name_sb100_irq[] = "Sound Blaster 1.0 (interrupt driven)";

static int sb_16bit    = _FALSE;			/* in 16 bit mode? */
static int sb_stereo   = _FALSE;			/* in stereo mode? */
static int sb_type	   = 0;


static DWORD sb_interrupt_driven_dma_position = 0;

static DWORD sb_cursor_offset = 0;

static int sb_samples_per_interrupt = 64;
static int sb_current_address = 0;


#define SBTYPE_SB100   0x100
#define SBTYPE_SB201   0x201
#define SBTYPE_SBPRO   0x300
#define SBTYPE_SB16    0x400




static void _sb_voice(int state);
static int get_blaster(void);
static int sb_read_dsp_version(void);
static int sb_write_dsp(unsigned char byte);
static void sb_stereo_mode(int enable);
static void sb_set_sample_rate(unsigned int rate);
static int sb_interrupt(void);
static void sb_play_buffer(int size);
static void sb_stop(void);
static int _sb_reset_dsp(int);
static int sb_read_dsp(void);
static void _sb_dac_level(BYTE);
static void sb16_get_dma_and_irq(void);
static int sb201_interrupt_driven_interrupt(void);
static int sb100_interrupt_driven_interrupt(void);
static int sbpro_interrupt_driven_interrupt(void);




static int sb201_start(int rate_no);
static int sbpro_start(int rate_no);
static int sbpro_ex_start(int rate_no);
static int sb16_start(int rate_no);
static int sb16_ex_start(int rate_no);
static int sb_auto_detect_start(int rate_no);
static int sb201_interrupt_driven_start(int rate_no);
static int sb100_interrupt_driven_start(int rate_no);

static unsigned long sb100_get_next_addr(void);



static void sb_exit(void);


static int detectCMI8x38(void);
static int cmi8x38_as_sb16_start(int rate_no);

static DWORD cmi8x38_iobase = -1;
static char device_name_cmi8x38[]  = "CMI8338/8738 as SB16";


static int detectTrid4DWave(void);
static int trid4dwave_as_sb16_start(int rate_no);

static DWORD trid4dwave_iobase = -1;
static char device_name_trid4dwave[]  = "Trident 4DWave DX/NX as SB16";


/***********************  BLASTER END  ********************/






/***********************  ULTRASOUND  *********************/

static char device_name_ultrasound[]  = "Ultrasound";
static char device_name_ultrasound_max[]  = "Ultrasound Max";

static int ultrasound_start(int rate_no);
static void ultrasound_exit(void);

static int ultramax_start(int rate_no);

static int get_ultrasnd(void);
static DWORD u_get_current_location(BYTE voice);
static void u_upload(DWORD addr, BYTE data);
static volatile int u_dma_upload(DWORD addr, WORD count, DWORD gusaddr,
					int flag, DWORD addr2, WORD count2, DWORD gusaddr2);
static void u_start_dma_upload(DWORD addr, WORD count, DWORD gusaddr);
static DWORD convert_to_16bit(DWORD address);
static void u_abort_dma_upload(void);




static int u_prim_voice = 0;
static int u_base = -1;
static int u_cmd;
static int u_datal;
static int u_datah;
static int u_page;
static int u_status;
static int u_dram;
static DWORD u_freq_value = 0;
static int gf1_use_dma	= _FALSE;
static volatile int u_dma_busy_flag = _FALSE;
static volatile int u_twoflag = _FALSE;
static DWORD u_nextaddr;
static WORD  u_nextcount;
static DWORD u_nextgusaddr;



/***********************  ULTRASOUND END  *****************/




/***********************  ESS AUDIODRIVE  *****************/
static char device_name_ess_audiodrive[] = "ESS Audiodrive";
static int ess_start(int);
static void ess_exit(void);


/***********************  ESS AUDIODRIVE END  *************/



/**********************************************************
						   dma.c  from allegro
***********************************************************/


// 8bit DMAC
#define DMA1_STAT		0x08
#define DMA1_WCMD		0x08
#define DMA1_WREQ		0x09
#define DMA1_SNGL		0x0A
#define DMA1_MODE		0x0B
#define DMA1_CLRFF		0x0C
#define DMA1_MCLR		0x0D
#define DMA1_CLRM		0x0E
#define DMA1_WRTALL 	0x0F

// 16bit DMAC
#define DMA2_STAT		0xD0
#define DMA2_WCMD		0xD0
#define DMA2_WREQ		0xD2
#define DMA2_SNGL		0xD4
#define DMA2_MODE		0xD6
#define DMA2_CLRFF		0xD8
#define DMA2_MCLR		0xDA
#define DMA2_CLRM		0xDC
#define DMA2_WRTALL 	0xDE


#define DMA0_ADDR		0x00
#define DMA0_CNT		0x01
#define DMA1_ADDR		0x02
#define DMA1_CNT		0x03
#define DMA2_ADDR		0x04
#define DMA2_CNT		0x05
#define DMA3_ADDR		0x06
#define DMA3_CNT		0x07
#define DMA4_ADDR		0xC0
#define DMA4_CNT		0xC2
#define DMA5_ADDR		0xC4
#define DMA5_CNT		0xC6
#define DMA6_ADDR		0xC8
#define DMA6_CNT		0xCA
#define DMA7_ADDR		0xCC
#define DMA7_CNT		0xCE

#define DMA0_PAGE		0x87
#define DMA1_PAGE		0x83
#define DMA2_PAGE		0x81
#define DMA3_PAGE		0x82
#define DMA4_PAGE		0x8F
#define DMA5_PAGE		0x8B
#define DMA6_PAGE		0x89
#define DMA7_PAGE		0x8A


typedef struct {
   BYTE dma_disable;
   BYTE dma_enable;
   WORD page;
   WORD addr;
   WORD count;
   WORD single;
   WORD mode;
   WORD clear_ff;
   BYTE write;
   BYTE read;
} DMA_S;



static DMA_S mydma[] =
{
   /* channel 0 */
   { 0x04, 0x00, DMA0_PAGE, DMA0_ADDR, DMA0_CNT,
	 DMA1_SNGL, DMA1_MODE, DMA1_CLRFF, 0x48, 0x44 },

   /* channel 1 */
   { 0x05, 0x01, DMA1_PAGE, DMA1_ADDR, DMA1_CNT,
	 DMA1_SNGL,DMA1_MODE,DMA1_CLRFF,0x49,0x45 },

   /* channel 2 */
   { 0x06, 0x02, DMA2_PAGE, DMA2_ADDR, DMA2_CNT,
	 DMA1_SNGL, DMA1_MODE, DMA1_CLRFF, 0x4A, 0x46 },

   /* channel 3 */
   { 0x07, 0x03, DMA3_PAGE, DMA3_ADDR, DMA3_CNT,
	 DMA1_SNGL, DMA1_MODE, DMA1_CLRFF, 0x4B, 0x47 },

   /* channel 4 */
   { 0x04, 0x00, DMA4_PAGE, DMA4_ADDR, DMA4_CNT,
	 DMA2_SNGL, DMA2_MODE, DMA2_CLRFF, 0x48, 0x44 },

   /* channel 5 */
   { 0x05, 0x01, DMA5_PAGE, DMA5_ADDR, DMA5_CNT,
	 DMA2_SNGL, DMA2_MODE, DMA2_CLRFF, 0x49, 0x45 },

   /* channel 6 */
   { 0x06, 0x02, DMA6_PAGE, DMA6_ADDR, DMA6_CNT,
	 DMA2_SNGL, DMA2_MODE, DMA2_CLRFF, 0x4A, 0x46 },

   /* channel 7 */
   { 0x07, 0x03, DMA7_PAGE, DMA7_ADDR, DMA7_CNT,
	 DMA2_SNGL, DMA2_MODE, DMA2_CLRFF, 0x4B, 0x47 }
};


#if 0

static int _dma_allocate_mem(int bytes, int *sel, unsigned long *phys)
{
   int seg;

   /* allocate twice as much memory as we really need */
   seg = __dpmi_allocate_dos_memory((bytes*2 + 15) >> 4, sel);

   if (seg < 0) {
	  *sel = 0;
	  *phys = 0;
	  return -1;
   }

   *phys = seg << 4;

   /* if it crosses a page boundary, use the second half of the block */
   if ((*phys>>16) != ((*phys+bytes)>>16))
	  *phys += bytes;

   return 0;
}

#endif

static int _dma_allocate_mem(int *sel, unsigned long *phys)
{
	int seg;

	/* allocate twice as much memory as we really need */
	seg = __dpmi_allocate_dos_memory(131072 >> 4, sel); 	// 128K

	if (seg < 0) {
	   *sel = 0;
	   *phys = 0;
	   return _FALSE;
	}

   *phys = seg << 4;

   *phys = (*phys + 65535) & ~0xFFFF ;						// 64K boundary

   return _TRUE;
}




static void _dma_start(int channel, unsigned long addr, int size, int auto_init, int input)
{
   DMA_S *tdma;
   unsigned long page, offset;
   int mode;

   tdma = &mydma[channel];
   page = addr >> 16;

   if (channel >= 4) {
	  addr >>= 1;
	  size >>= 1;
   }

   offset = addr & 0xFFFF;
   size--;

   _dma_count = size;

   mode = (input) ? tdma->read : tdma->write;
   if (auto_init)
	  mode |= 0x10;

   outportb(tdma->single, tdma->dma_disable);
   outportb(tdma->mode, mode);
   outportb(tdma->clear_ff, 0);
   outportb(tdma->addr, offset & 0xFF);
   outportb(tdma->addr, offset >> 8);
   outportb(tdma->page, page);
   outportb(tdma->clear_ff, 0);
   outportb(tdma->count, size & 0xFF);
   outportb(tdma->count, size >> 8);
   outportb(tdma->single, tdma->dma_enable);
}




static void _dma_stop(int channel)
{
   DMA_S *tdma = &mydma[channel];
   outportb(tdma->single, tdma->dma_disable);
}







static DWORD _dma_todo(int channel)
{
	int val1, val2 = 0;
	DMA_S *tdma = &mydma[channel];
	int _dma_todo_limit = 0;

	outportb(tdma->clear_ff, 0xff);
	while(_dma_todo_limit < 1024){
		val1  = inportb(tdma->count);
		val1 |= inportb(tdma->count) << 8;
		val2  = inportb(tdma->count);
		val2 |= inportb(tdma->count) << 8;
		val1 -= val2;
		if(0 <= val1 && val1 < 8) break;
		_dma_todo_limit += 1;
	}
	if(val2 > _dma_count) val2 = _dma_count;
	if(channel > 3) val2 <<= 1;
	return val2;
}



/**********************************************************
						dma.c end
***********************************************************/




static DWORD tasmania = 0;

void w_enter_critical(void)
{
	tasmania += 1;
	if(tasmania == 1){
		asm volatile("cli");
	}
}

void w_exit_critical(void)
{
	tasmania -= 1;
	if(tasmania == 0){
		asm volatile("sti");
	}
}
















static void copy_to_dos_memory(DWORD offset, BYTE *ptr, DWORD length)
{
	int d0;

	_farsetsel(_dos_ds);
	d0 = 0;
	while(d0 < length){
		_farnspokeb(d0 + offset, *(ptr + d0));
		d0 += 1;
	}
}


static void eoi(int irq)
{
	outportb(0x20, 0x20);
	if (irq > 7) outportb(0xA0, 0x20);
}

static void unmask_irq(int irq)
{
	BYTE d0;

	d0 = inportb(0x21);

	if (irq > 7) {
		outportb(0x21, d0 & 0xFB);
		d0 = inportb(0xA1);
		outportb(0xA1, d0 & ~(1<<(irq-8)) );
   }else{
	  outportb(0x21, d0 & (~(1<<irq)) );
   }
}



static void mask_irq(int irq)
{
	BYTE d0;

	if (irq > 7) {
		d0 = inportb(0xA1);
		outportb(0xA1, d0 | (1<<(irq-8)));
	}else{
		d0 = inportb(0x21);
		outportb(0x21, d0 | (1<<irq));
	}
}


static int install_irq_handler(int irq, void *my_handler)
{
	int bl = _TRUE;
	int irq_vector = 0;

	if( !(0 <= irq && irq <= 15) ) return _FALSE;

	if(irq < 8){
		irq_vector = irq + 0x08;
	}else{
		irq_vector = irq - 8 + 0x70;
	}

	if(old_handler_irq_vector == -1){
		old_handler_irq_vector = irq_vector;
		_go32_dpmi_get_protected_mode_interrupt_vector(irq_vector, &old_handler);
		new_handler.pm_offset = (long)my_handler;
		_go32_dpmi_allocate_iret_wrapper(&new_handler);
		_go32_dpmi_set_protected_mode_interrupt_vector(irq_vector, &new_handler);
	}else{
		bl = _FALSE;
	}

	return bl;
}

static void restore_irq_handler(void)
{
	if(old_handler_irq_vector != -1){
		_go32_dpmi_set_protected_mode_interrupt_vector(old_handler_irq_vector, &old_handler);
		_go32_dpmi_free_iret_wrapper(&new_handler);
		old_handler_irq_vector = -1;
	}
}




/***********************  BLASTER  ************************/

static int sb100_interrupt_driven_start(int rate_no)
{
	int rate;
	int ver = -1;

	switch(rate_no){
		case 1:
			rate = 11111;
			sb_samples_per_interrupt = 16;
			break;
		case 2:
			rate = 21739;
			sb_samples_per_interrupt = 32;
			break;
		default:
			rate = 21739;
			sb_samples_per_interrupt = 32;
	}

	g_device_sample_rate = rate;
	pcm_format = _8BITMONO;

	if( get_blaster() == _FALSE ){
		error_mes = error_mes_blaster_not_found;
		return _FALSE;
	}

	sb_16bit  = _FALSE;
	sb_stereo = _FALSE;
	sb_type   = SBTYPE_SB100;

	if(_sb_reset_dsp(1) != 0){
		error_mes = error_mes_sb_reset_dsp_failed;
		return _FALSE;
	}

	ver = sb_read_dsp_version();
	if(ver < 0){
		error_mes = error_mes_sb_read_dsp_ver_failed;
		return _FALSE;
	}

	if(__dma_allocate_mem(_8BITMONO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}
	unmask_irq(g_irq);
	install_irq_handler(g_irq, (void*)sb100_interrupt_driven_interrupt);
	_sb_voice(_TRUE);
//	  sb_stereo_mode(sb_stereo);
	sb_set_sample_rate(rate);


	sb_current_address = 0;
	_dma_start(g_dma, sb100_get_next_addr(), sb_samples_per_interrupt, _FALSE, _FALSE);
	sb_interrupt_driven_dma_position = SAMPLECNT - sb_current_address - 1;
	sb_interrupt_driven_dma_position -= sb_cursor_offset;
	sb_interrupt_driven_dma_position &= SAMPLECNTMASK;
	sb_play_buffer(sb_samples_per_interrupt);

	if(ver >= 0x300){
		_sb_dac_level(0xFF);
	}

	device_name = device_name_sb100_irq;
	DMACTYPE = DMACTYPE_SB100IRQ;
	DEVICE	 = DEVICE_SB100;

	return _TRUE;
}


static unsigned long sb100_get_next_addr(void)
{
	unsigned long d0;

	d0 = g_wss_dma_addr + sb_current_address;
	sb_current_address += sb_samples_per_interrupt;
	sb_current_address &= SAMPLECNTMASK;

	return d0;
}


static int sb100_interrupt_driven_interrupt(void)
{
	inportb(g_port+0x0E);
	eoi(g_irq); 						/* acknowledge interrupt */

	_dma_start(g_dma, sb100_get_next_addr(), sb_samples_per_interrupt, _FALSE, _FALSE);
	sb_interrupt_driven_dma_position  = SAMPLECNT - sb_current_address - 1;
	sb_interrupt_driven_dma_position -= sb_cursor_offset;
	sb_interrupt_driven_dma_position &= SAMPLECNTMASK;

	sb_play_buffer(sb_samples_per_interrupt);


	return 0;
}




static int sb201_interrupt_driven_start(int rate_no)
{
	int rate;
	int ver  = -1;

	switch(rate_no){
		case 1:
			rate = 11111;
			sb_samples_per_interrupt = 32;
			break;
		case 2:
			rate = 21739;
			sb_samples_per_interrupt = 64;
			break;
		case 4:
			rate = 45454;
			sb_samples_per_interrupt = 128;
			break;
		default:
			rate = 21739;
			sb_samples_per_interrupt = 64;
	}

	g_device_sample_rate = rate;
	pcm_format = _8BITMONO;

	if( get_blaster() == _FALSE ){
		error_mes = error_mes_blaster_not_found;
		return _FALSE;
	}

	sb_16bit  = _FALSE;
	sb_stereo = _FALSE;
	sb_type   = SBTYPE_SB201;

	if(_sb_reset_dsp(1) != 0){
		error_mes = error_mes_sb_reset_dsp_failed;
		return _FALSE;
	}

	ver = sb_read_dsp_version();
	if(ver < 0){
		error_mes = error_mes_sb_read_dsp_ver_failed;
		return _FALSE;
	}

	if(__dma_allocate_mem(_8BITMONO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}
	unmask_irq(g_irq);
	install_irq_handler(g_irq, (void*)sb201_interrupt_driven_interrupt);
	_sb_voice(_TRUE);
//	  sb_stereo_mode(sb_stereo);
	sb_set_sample_rate(rate);

	_dma_start(g_dma, g_wss_dma_addr, g_dma_buff_size, _TRUE, _FALSE);

	sb_interrupt_driven_dma_position  = SAMPLECNT - 1;
	sb_interrupt_driven_dma_position -= sb_cursor_offset;
	sb_interrupt_driven_dma_position -= sb_samples_per_interrupt;
	sb_interrupt_driven_dma_position &= (SAMPLECNT - 1);

	sb_play_buffer(sb_samples_per_interrupt);

	if(ver >= 0x300){
		_sb_dac_level(0xFF);
	}

	device_name = device_name_sb201_irq;
	DMACTYPE = DMACTYPE_SB201IRQ;
	DEVICE	 = DEVICE_SB201;

	return _TRUE;
}

static int sb201_interrupt_driven_interrupt(void)
{
	sb_interrupt_driven_dma_position -= sb_samples_per_interrupt;
	sb_interrupt_driven_dma_position &= (SAMPLECNT - 1);

	inportb(g_port+0x0E);
	eoi(g_irq); 						/* acknowledge interrupt */
	return 0;
}


static int sbpro_interrupt_driven_start(int rate_no)
{
	int rate;
	int ver  = -1;

	switch(rate_no){
		case 1:
			rate = 11111;
			sb_samples_per_interrupt = 32;
			break;
		case 2:
			rate = 21739;
			sb_samples_per_interrupt = 64;
			break;
		default:
			rate = 21739;
			sb_samples_per_interrupt = 64;
	}

	g_device_sample_rate = rate;
	pcm_format = _8BITSTEREO;

	if( get_blaster() == _FALSE ){
		error_mes = error_mes_blaster_not_found;
		return _FALSE;
	}

	sb_16bit  = _FALSE;
	sb_stereo = _TRUE;
	sb_type   = SBTYPE_SBPRO;

	if(_sb_reset_dsp(1) != 0){
		error_mes = error_mes_sb_reset_dsp_failed;
		return _FALSE;
	}

	ver = sb_read_dsp_version();
	if(ver < 0){
		error_mes = error_mes_sb_read_dsp_ver_failed;
		return _FALSE;
	}

	if(__dma_allocate_mem(_8BITSTEREO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}
	unmask_irq(g_irq);
	install_irq_handler(g_irq, (void*)sbpro_interrupt_driven_interrupt);
	_sb_voice(_TRUE);
	sb_stereo_mode(sb_stereo);
	sb_set_sample_rate(rate);

	_dma_start(g_dma, g_wss_dma_addr, g_dma_buff_size, _TRUE, _FALSE);

	sb_interrupt_driven_dma_position  = (SAMPLECNT * 2) - 1;
	sb_interrupt_driven_dma_position -= (sb_cursor_offset * 2);
	sb_interrupt_driven_dma_position -= (sb_samples_per_interrupt * 2);
	sb_interrupt_driven_dma_position &= ((SAMPLECNT * 2) - 1);

	sb_play_buffer(sb_samples_per_interrupt * 2);

	if(ver >= 0x300){
		_sb_dac_level(0xFF);
	}

	device_name = device_name_sbpro_irq;
	DMACTYPE = DMACTYPE_SB201IRQ;
	DEVICE	 = DEVICE_SBPRO;

	return _TRUE;
}


static int sbpro_interrupt_driven_interrupt(void)
{
	sb_interrupt_driven_dma_position -= (sb_samples_per_interrupt * 2);
	sb_interrupt_driven_dma_position &= ((SAMPLECNT * 2) - 1);

	inportb(g_port+0x0E);
	eoi(g_irq); 						/* acknowledge interrupt */
	return 0;
}



static int sb_auto_detect_start(int rate_no)
{
	int result;
	int ver;

	get_blaster();
	if(g_port < 0){
		error_mes = error_mes_blaster_not_found;
		return _FALSE;
	}

	ver = sb_read_dsp_version();
	if(ver < 0){
		error_mes = error_mes_sb_read_dsp_ver_failed;
		return _FALSE;
	}

	if(ver < 0x201){
		result = sb100_interrupt_driven_start(rate_no);
	}else if(0x201 <= ver && ver < 0x300){
		result = sb201_start(rate_no);
	}else if(0x300 <= ver && ver < 0x400){
		result = sbpro_start(rate_no);
	}else{
		sb16_get_dma_and_irq();
		result = sb16_start(rate_no);
	}
	return result;
}





static int sbpro_ex_start(int rate_no)
{
	int result;
	int rate;

	switch(rate_no){
		case 1:
			rate = 11111;
			break;
		case 2:
			rate = 31250;
			break;
		case 3:
			rate = 32000;
			break;
		case 4:
			rate = 45454;
			break;
		case 5:
			rate = 47619;
			break;
		default:
			rate = 21739;
	}

	result = sbpro_start(rate);
	if(result != _FALSE){
		device_name = device_name_sbpro_ex;
	}
	return result;
}

static int sb16_ex_start(int rate_no)
{
	int result;
	int rate;

	switch(rate_no){
		case 1:
			rate = 16000;
			break;
		case 2:
			rate = 24000;
			break;
		case 3:
			rate = 32000;
			break;
		case 4:
			rate = 40000;
			break;
		case 5:
			rate = 48000;
			break;
		case 6:
			rate = 64000;
			break;
		default:
			rate = 48000;
	}

	result = sb16_start(rate);
	if(result != _FALSE){
		device_name = device_name_sb16_ex;
	}
	return result;
}



/*	from Allegro sb.c  */
static int sb201_start(int rate_no)
{
	int rate = 21739;
	int ver  = -1;

	switch(rate_no){
		case 1:
			rate = 11111;
			break;
		case 2:
			rate = 21739;
			break;
		case 3:
			rate = 32258;
			break;
		case 4:
			rate = 45454;
			break;
		default:
			rate = 21739;
	}

	g_device_sample_rate = rate;
	pcm_format = _8BITMONO;

	if( get_blaster() == _FALSE ){
		error_mes = error_mes_blaster_not_found;
		return _FALSE;
	}

	sb_16bit  = _FALSE;
	sb_stereo = _FALSE;
	sb_type   = SBTYPE_SB201;

	if(_sb_reset_dsp(1) != 0){
		error_mes = error_mes_sb_reset_dsp_failed;
		return _FALSE;
	}

	ver = sb_read_dsp_version();
	if(ver < 0){
		error_mes = error_mes_sb_read_dsp_ver_failed;
		return _FALSE;
	}

	if(__dma_allocate_mem(_8BITMONO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}
	unmask_irq(g_irq);
	install_irq_handler(g_irq, (void*)sb_interrupt);
	_sb_voice(_TRUE);
//	  sb_stereo_mode(sb_stereo);
	sb_set_sample_rate(rate);

	_dma_start(g_dma, g_wss_dma_addr, g_dma_buff_size, _TRUE, _FALSE);

//	  sb_play_buffer(g_dma_buff_size);
	sb_play_buffer(2048);

	if(ver >= 0x300){
		_sb_dac_level(0xFF);
	}

	device_name = device_name_sb201;
	DMACTYPE = DMACTYPE_NORMAL;
	DEVICE	 = DEVICE_SB201;

	return _TRUE;
}



/*	from Allegro sb.c  */
static int sbpro_start(int rate_no)
{
	int rate = 21739;

	if(rate_no < 8000){
		switch(rate_no){
			case 1:
				rate = 11111;
				break;
			case 2:
				rate = 21739;
				break;
			default:
				rate = 21739;
		}
	}else{
		rate = rate_no;
	}
	g_device_sample_rate = rate;
	pcm_format = _8BITSTEREO;

	if( get_blaster() == _FALSE ){
		error_mes = error_mes_blaster_not_found;
		return _FALSE;
	}

	sb_16bit  = _FALSE;
	sb_stereo = _TRUE;
	sb_type   = SBTYPE_SBPRO;

	if(_sb_reset_dsp(1) != 0){
		error_mes = error_mes_sb_reset_dsp_failed;
		return _FALSE;
	}
	if(__dma_allocate_mem(_8BITSTEREO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}
	unmask_irq(g_irq);
	install_irq_handler(g_irq, (void*)sb_interrupt);
	_sb_voice(_TRUE);
	sb_stereo_mode(sb_stereo);
	sb_set_sample_rate(rate);

	_dma_start(g_dma, g_wss_dma_addr, g_dma_buff_size, _TRUE, _FALSE);

//	  sb_play_buffer(g_dma_buff_size);
	sb_play_buffer(2048);
	_sb_dac_level(0xFF);

	device_name = device_name_sbpro;
	DMACTYPE = DMACTYPE_NORMAL;
	DEVICE	 = DEVICE_SBPRO;

	return _TRUE;
}


/*	from Allegro sb.c  */
static int sb16_start(int rate_no)
{
	int rate = 44100;

	if(rate_no < 8000){
		switch(rate_no){
			case 1:
				rate = 11025;
				break;
			case 2:
				rate = 22050;
				break;
			case 3:
				rate = 33075;
				break;
			case 4:
				rate = 44100;
				break;
			default:
				rate = 44100;
		}
	}else{
		rate = rate_no;
	}
	g_device_sample_rate = rate;
	pcm_format = _16BITSTEREO;

	if( get_blaster() == _FALSE ){
		error_mes = error_mes_blaster_not_found;
		return _FALSE;
	}
	g_dma = g_hdma;

	sb_16bit  = _TRUE;		   // cmd Bxh
	sb_stereo = _TRUE;
	sb_type   = SBTYPE_SB16;

	if(_sb_reset_dsp(1) != 0){
		error_mes = error_mes_sb_reset_dsp_failed;
		return _FALSE;
	}
	if(__dma_allocate_mem(_16BITSTEREO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}
	unmask_irq(g_irq);
	install_irq_handler(g_irq, (void*)sb_interrupt);
	_sb_voice(_TRUE);
	sb_set_sample_rate(rate);

	_dma_start(g_dma, g_wss_dma_addr, g_dma_buff_size, _TRUE, _FALSE);

//	  sb_play_buffer(g_dma_buff_size);
	sb_play_buffer(2048);
	_sb_dac_level(0xFF);

	device_name = device_name_sb16;
	DMACTYPE = DMACTYPE_NORMAL;
	DEVICE	 = DEVICE_SB16;

	return _TRUE;
}


static int cmi8x38_as_sb16_start(int rate_no)
{
	int rate;

	switch(rate_no){
		case 1:
			rate = 11025;
			break;
		case 2:
			rate = 22050;
			break;
		case 3:
			rate = 33075;
			break;
		case 4:
			rate = 44100;
			break;
		case 5:
			rate = 48000;
			break;
		default:
			rate = 44100;
	}

	if( detectCMI8x38() == _FALSE ){
		error_mes = error_mes_cmi8x38_not_found;
		return _FALSE;
	}
	if( get_blaster() == _FALSE ){
		error_mes = error_mes_blaster_not_found;
		return _FALSE;
	}
	sb16_get_dma_and_irq();

	sb16_start(rate);

	device_name = device_name_cmi8x38;
	DMACTYPE = DMACTYPE_CMI8x38;

	return _TRUE;
}



static int GetSBDelta(int rate)
{
	double f0;

	f0 = (double)rate / 48000;

	return (int)(f0 * (1 << 12));
}

static int GetSampleRate(int sbdelta)
{
	double f0;

	f0 = sbdelta;

	return (int)((f0 * 48000) / (1 << 12));
}

static int SetSBDelta(DWORD iobase, int sbdelta)
{
	outportw(iobase + 0xAC, sbdelta & 0xFFFF);
	return _TRUE;
}



static int trid4dwave_as_sb16_start(int rate_no)
{
	int rate;
	int rate1;
	int rate2;
	int sbdelta;

	switch(rate_no){
		case 1:
			rate = 11025;
			break;
		case 2:
			rate = 24000;
			break;
		case 3:
			rate = 32000;
			break;
		case 4:
			rate = 44100;
			break;
		case 5:
			rate = 48000;
			break;
		case 6:
			rate = 64000;
			break;
		default:
			rate = 44100;
	}

	if( detectTrid4DWave() == _FALSE ){
		error_mes = error_mes_trid4dwave_not_found;
		return _FALSE;
	}

	sbdelta = GetSBDelta(rate);
	rate1 = GetSampleRate(sbdelta);
	rate2 = GetSampleRate(sbdelta + 1);
	if(rate > rate1)
		rate1 = rate - rate1;
	else
		rate1 = rate1 - rate;
	if(rate > rate2)
		rate2 = rate - rate2;
	else
		rate2 = rate2 - rate;
	if(rate1 > rate2)
		sbdelta += 1;
	SetSBDelta(trid4dwave_iobase, sbdelta);

	sb16_start(rate);

	device_name = device_name_trid4dwave;
	DMACTYPE = DMACTYPE_4DWAVE;

	return _TRUE;
}







/*	from Allegro sb.c  */
static int sb_read_dsp_version()
{
	int sb_hw_dsp_ver = -1;
	int x, y;

	if (g_port > 0){
		if (_sb_reset_dsp(1) != 0) {
			sb_hw_dsp_ver = -1;
		}
		else {
			sb_write_dsp(0xE1);
			x = sb_read_dsp();
			y = sb_read_dsp();
			sb_hw_dsp_ver = ((x << 8) | y);
		}
	}
	return sb_hw_dsp_ver;
}



static void _sb_dac_level(BYTE d0)
{
	outportb(g_port + 4, 4);
	outportb(g_port + 5, d0);
}


static void _sb_voice(int state)
{
	if (state == _TRUE) {
		sb_write_dsp(0xD1);
	}else{
		sb_write_dsp(0xD3);
	}
}





static int get_blaster(void)
{
	char *wsscfg = getenv("BLASTER");
	if (wsscfg != NULL) {
		while (*wsscfg) {
			while ((*wsscfg == ' ') || (*wsscfg == '\t')){
				wsscfg++;
			}
			if (*wsscfg) {
				switch (*wsscfg) {
					case 'a': case 'A':
						g_port = strtol(wsscfg+1, NULL, 16);
						break;

					case 'i': case 'I':
						g_irq = strtol(wsscfg+1, NULL, 10);
						if(g_irq == 2) g_irq = 9;
						break;

					case 'd': case 'D':
						g_dma = strtol(wsscfg+1, NULL, 10);
						break;

					case 'h': case 'H':
						g_hdma = strtol(wsscfg+1, NULL, 10);
						break;
				}
				while ((*wsscfg) && (*wsscfg != ' ') && (*wsscfg != '\t'))
					wsscfg++;
			}
		}
	}


	if ((g_port < 0) || (g_irq < 0) || (g_dma < 0))
		return _FALSE;
	if(g_hdma < 0)
		g_hdma = g_dma;

	return _TRUE;
}

static int sb_write_dsp(unsigned char byte)
{
   int x;

   for (x=0; x<0xFFFF; x++) {
	  if (!(inportb(0x0C + g_port) & 0x80)) {
	 outportb(0x0C + g_port, byte);
	 return 0;
	  }
   }
   return -1;
}


static void sb_play_buffer(int size)
{
	if (sb_type == SBTYPE_SB201 || sb_type == SBTYPE_SBPRO){	/* 8 bit high-speed auto-initialised */
		sb_write_dsp(0x48);
		sb_write_dsp((size-1) & 0xFF);
		sb_write_dsp((size-1) >> 8);
		sb_write_dsp(0x90);
	}else if(sb_type == SBTYPE_SB100){
		sb_write_dsp(0x14);
		sb_write_dsp((size-1) & 0xFF);
		sb_write_dsp((size-1) >> 8);
	}else if(sb_type == SBTYPE_SB16){						  /* 16 bit */
		size /= 2;
		sb_write_dsp(0xB6);
		sb_write_dsp(0x30);
		sb_write_dsp((size-1) & 0xFF);
		sb_write_dsp((size-1) >> 8);
	}
}

static void sb_stereo_mode(int enable)
{
   outportb(g_port+0x04, 0x0E);
   outportb(g_port+0x05, ((enable == _TRUE) ? 2 : 0));
}

static void sb_set_sample_rate(unsigned int rate)
{
	if (sb_type == SBTYPE_SB16){
		sb_write_dsp(0x41);
		sb_write_dsp(rate >> 8);
		sb_write_dsp(rate & 0xff);
	}else{
		if(sb_stereo == _TRUE)
			rate *= 2;
		sb_write_dsp(0x40);
		sb_write_dsp((unsigned char)(256 - (1000000 / rate)));
	}
}


static int sb_interrupt(void)
{
   if (sb_16bit == _TRUE)							  /* acknowledge SB */
	  inportb(g_port+0x0F);
   else
	  inportb(g_port+0x0E);

   eoi(g_irq);						   /* acknowledge interrupt */
   return 0;
}

static void sb_exit(void)
{
	if(DEVICE == DEVICE_SB16  ||
	   DEVICE == DEVICE_SBPRO ||
	   DEVICE == DEVICE_SB201 ||
	   DEVICE == DEVICE_SB100	)
	{
		sb_stop();
		_dma_stop(g_dma);
		mask_irq(g_irq);
		restore_irq_handler();
		__dpmi_free_dos_memory(g_wss_dma_sel);
		DEVICE = DEVICE_NONE;
	}
}


static void sb_stop(void)
{
   /* halt sound output */
   _sb_voice(_FALSE);

	if(sb_type == SBTYPE_SB16){
		sb_write_dsp(0xD5);
		sb_write_dsp(0xD9);
		sb_write_dsp(0xD5);
	}

   _sb_reset_dsp(1);
}


static int _sb_reset_dsp(int d0)
{
	int val;
	int cwait;
	int result;
	int d7;

	result = -1;
	cwait = 8;
	while(cwait <= 1024){
		w_enter_critical();
		outportb(0x06 + g_port, d0);
		d7 = 0;
		while(d7 < cwait){
			inportb(0x06 + g_port);
			d7 += 1;
		}
		outportb(0x06 + g_port, 0);
		w_exit_critical();
		for(d7 = 0 ; d7 < 4 ; d7 += 1){
			val = sb_read_dsp();
			if(val == -1) continue;
			if(val == 0xAA){
				result = 0;
				break;
			}
			break;
		}
		if(result == 0) break;
		cwait = cwait * 2;
	}
	return result;
}

static int sb_read_dsp(void)
{
   int x;

   for (x=0; x<0xFFFF; x++)
	  if (inportb(0x0E + g_port) & 0x80)
	 return inportb(0x0A + g_port);

   return -1;
}


static void sb16_get_dma_and_irq(void)
{
	int d0;

	outportb(g_port + 4, 0x81);
	d0 = inportb(g_port + 5);
	if(d0 & 0x01) g_dma = 0;
	if(d0 & 0x02) g_dma = 1;
	if(d0 & 0x04) g_dma = 2;
	if(d0 & 0x08) g_dma = 3;
	if(d0 & 0x10) g_hdma = 4;
	if(d0 & 0x20) g_hdma = 5;
	if(d0 & 0x40) g_hdma = 6;
	if(d0 & 0x80) g_hdma = 7;

	outportb(g_port + 4, 0x80);
	d0 = inportb(g_port + 5);
	if(d0 & 0x01) g_irq = 9;
	if(d0 & 0x02) g_irq = 5;
	if(d0 & 0x04) g_irq = 7;
	if(d0 & 0x08) g_irq = 10;
}






static int get_wsscfg(void)
{
	char *wsscfg = getenv("WSSCFG");
	if (wsscfg != NULL) {
		while (*wsscfg) {
			while ((*wsscfg == ' ') || (*wsscfg == '\t')){
				wsscfg++;
			}
			if (*wsscfg) {
				switch (*wsscfg) {
					case 'a': case 'A':
						g_port = strtol(wsscfg+1, NULL, 16);
						break;

					case 'i': case 'I':
						g_irq = strtol(wsscfg+1, NULL, 10);
						break;

					case 'd': case 'D':
						g_dma = strtol(wsscfg+1, NULL, 10);
						break;
				}
				while ((*wsscfg) && (*wsscfg != ' ') && (*wsscfg != '\t'))
					wsscfg++;
			}
		}
	}


//	  if ((g_port < 0) || (g_irq < 0) || (g_dma < 0))
	if ((g_port < 0) || (g_dma < 0))
		return _FALSE;

	return _TRUE;
}

static void _wssout(BYTE d0, BYTE d1)
{
	outportb(IADDR, d0);
	outportb(IDATA, d1);
}


static void wss_wait(void)
{
   int i = 0xFFFF;

   while ((inportb(g_port + 4) & INIT) || (i-- > 0));
}









static int wss_irq_handler(void)
{
	outportb(STATUS, 0);
	eoi(g_irq);
	return 0;
}



static int get_ultra16(void)
{
	int max_port  = -1;
	int max_pdma  = -1;
	int max_irq   = -1;
	int max_type  = -1;
	int max_cdrom = -1;
	char *wsscfg = getenv("ULTRA16");

	if(get_ultrasnd() == _FALSE) return _FALSE;

	if (wsscfg != NULL) {
		sscanf(wsscfg, "%x,%d,%d,%d,%d",
			&max_port, &max_pdma, &max_irq, &max_type, &max_cdrom);
	}
	if( (max_port < 0) || (max_pdma < 0) || (max_type < 0) || (max_irq < 0) ) return _FALSE;
	if(max_type == 0){
		g_port = max_port;
		g_dma  = max_pdma;
		g_irq  = max_irq;
	}else{
		g_port = max_port - 4;
		g_dma  = g_hdma;
	}
	return _TRUE;
}



static int es1370_as_soundscape_start(int rate_no)
{
	DWORD d0;

	if(detectES1370() == _FALSE){
		error_mes = error_mes_es1370_not_found;
		return _FALSE;
	}
	if(soundscape_get_init_config() == _FALSE) return _FALSE;
	rate_no = 5;
	if(wss_start(rate_no) == _FALSE) return _FALSE;
	d0 = inportl(audiopci_iobase);
	d0 = d0 & ~0x1FFF0000;
	d0 = d0 | (20 << 16);
	outportl(audiopci_iobase, d0);
	g_device_sample_rate = 64145;
	device_name = device_name_es1370;
	return _TRUE;
}

static int soundscape_start(int rate_no)
{
	if(soundscape_get_init_config() == _FALSE) return _FALSE;
	if(wss_start(rate_no) == _FALSE) return _FALSE;
	device_name = device_name_soundscape;
	return _TRUE;
}

static int ultramax_start(int rate_no)
{
	if(get_ultra16() == _FALSE){
		error_mes = error_mes_ultra16_not_found;
		return _FALSE;
	}
	if(wss_start(rate_no) == _FALSE) return _FALSE;
	device_name = device_name_ultrasound_max;
	return _TRUE;
}


static int ev1935_as_wss_start(int rate_no)
{
	if(detectEV1935() == _FALSE){
		error_mes = error_mes_ev1935_not_found;
		return _FALSE;
	}
	if(wss_start(rate_no) == _FALSE) return _FALSE;

	ev1935_iobase += g_dma * 0x10;

	device_name = device_name_ev1935_as_wss;
	DMACTYPE = DMACTYPE_EV1935;

	return _TRUE;
}

static int ev1935_as_sbpro_start(int rate_no)
{
	if(detectEV1935() == _FALSE){
		error_mes = error_mes_ev1935_not_found;
		return _FALSE;
	}
	if(sbpro_start(rate_no) == _FALSE) return _FALSE;

	ev1935_iobase += g_dma * 0x10;

	device_name = device_name_ev1935_as_sbpro;
	DMACTYPE = DMACTYPE_EV1935;

	return _TRUE;
}



/*	from Allegro wss.c	*/
static int wss_start(int rate_no)
{
	int i;
	int rate = 48000;
	int wss_usedrate;
	int wss_stereo;
	int wss_16bits;
	int nsamples;

	switch(rate_no){
		case 1:
			rate = 11025;
			wss_usedrate = 4;
			break;
		case 2:
			rate = 22050;
			wss_usedrate = 7;
			break;
		case 3:
			rate = 33075;
			wss_usedrate = 10;
			break;
		case 4:
			rate = 44100;
			wss_usedrate = 12;
			break;
		case 5:
			rate = 48000;
			wss_usedrate = 13;
			break;
		case 6:
			rate = 64000;
			wss_usedrate = 15;
			break;
		default:
			rate = 48000;
			wss_usedrate = 13;
	}
	g_device_sample_rate = rate;
	pcm_format = _16BITSTEREO;

	wss_stereo = _TRUE;
	wss_16bits = _TRUE;
	if( get_wsscfg() == _FALSE ){
		error_mes = error_mes_wsscfg_not_found;
		return _FALSE;
	}
	if(__dma_allocate_mem(_16BITSTEREO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}

	nsamples = SAMPLECNT;

	_wssout(LADC, 0);
	_wssout(RADC, 0);
	_wssout(LAUX1, 0);
	_wssout(RAUX1, 0);
	_wssout(LAUX2, 0);
	_wssout(RAUX2, 0);
	_wssout(LDAC, 0x80);
	_wssout(RDAC, 0x80);
	_wssout(LOOPBCK, 0);
	_wssout(MODE_ID, 0x8A);

	/* Enable MCE */
	outportb(IADDR, MCE | INTCON);
	wss_wait();

	outportb(IDATA, 0x18);
	wss_wait();

	/* Disable MCE */
	outportb(IADDR, ERRSTAT);

	i = 0xFFFF;

	while ((inportb(IDATA) & 0x20) && (i-- > 0));

	if (i < 1)
	   return -1;

	/* Enter MCE */
	outportb(IADDR, MCE | FS);
	wss_wait();

	/* Set playback format */
	i = codec_rates[wss_usedrate].divider;
	if (wss_stereo)
	   i |= 0x10;
	if (wss_16bits)
	   i |= 0x40;
	outportb(IDATA, i);
	wss_wait();

	outportb(IADDR, 0);
	outportb(STATUS, 0);
	outportb(IADDR, PINCON);
	wss_wait();
//	  outportb(IDATA, 0x2);
	outportb(IDATA, 0x00);

//	  unmask_irq(g_irq);
//	  install_irq_handler(g_irq, (void*)wss_irq_handler);

	_dma_start(g_dma, g_wss_dma_addr, g_dma_buff_size, _TRUE, _FALSE);

	eoi(g_irq);

	outportb(IADDR, PB_UCNT);
	wss_wait();
	outportb(IDATA, (nsamples - 1) >> 8);
	outportb(IADDR, PB_LCNT);
	wss_wait();
	outportb(IDATA, (nsamples - 1) & 0xFF);
	wss_wait();
	outportb(IADDR, INTCON | MCE);
	wss_wait();
	outportb(IDATA, 0x5);
	outportb(IADDR, 0);

	_wssout(LDAC, 0);
	_wssout(RDAC, 0);

	device_name = device_name_windows_sound_system;
	DMACTYPE = DMACTYPE_NORMAL;
	DEVICE	 = DEVICE_WSS;

	return _TRUE;
}

static void wss_exit(void)
{
	if(DEVICE == DEVICE_WSS){
		/* Mute outputs */
		_wssout(LDAC, 0x80);
		_wssout(RDAC, 0x80);

		_dma_stop(g_dma);

		/* Stop playback */
		outportb(IADDR, MCE | INTCON);
		wss_wait();
		outportb(IDATA, 0);
		outportb(IADDR, 0);
		outportb(STATUS, 0);
//		  mask_irq(g_irq);
//		  restore_irq_handler();
		__dpmi_free_dos_memory(g_wss_dma_sel);
		DEVICE = DEVICE_NONE;
	}
}


static int __dma_allocate_mem(int flag)
{
	BYTE *a0;
	int d0;

	g_dma_buff_size = SAMPLECNT;
	switch(flag){
		case _8BITMONO:
			g_dma_buff_size *= 1;
			g_dmacnt_shift_count = 0;
			break;
		case _8BITSTEREO:
			g_dma_buff_size *= 2;
			g_dmacnt_shift_count = 1;
			break;
		case _16BITSTEREO:
			g_dma_buff_size *= 4;
			g_dmacnt_shift_count = 2;
			break;
		default:
			g_dma_buff_size = 0;
	}
	if(g_dma_buff_size == 0) return _FALSE;
	a0 = malloc(g_dma_buff_size);
	if(a0 == NULL) return _FALSE;
	if (_dma_allocate_mem(&g_wss_dma_sel, &g_wss_dma_addr) == _FALSE)
		return _FALSE;
	d0 = 0;
	while(d0 < g_dma_buff_size){
		if(flag == _8BITSTEREO || flag == _8BITMONO)
			a0[d0] = 0x80;
		else
			a0[d0] = 0x00;
		d0 += 1;
	}
	copy_to_dos_memory(g_wss_dma_addr, a0, g_dma_buff_size);
	free(a0);

	return _TRUE;
}








static void u_delay(void)
{
	int d0;

	d0 = 0;
	while(d0 < 7){
		inportb(u_dram);
		d0 += 1;
	}
}

static void u_voice_no(BYTE data)
{
	outportb(u_page, data);
}

static void u_cmdwb(BYTE _index, BYTE data)
{
	outportb(u_cmd,   _index);
	outportb(u_datah, data);
}

static BYTE u_cmdrb(BYTE _index)
{
	outportb(u_cmd, _index);
	return inportb(u_datah);
}

static void u_cmdww(BYTE _index, WORD data)
{
	outportb(u_cmd,   _index);
	outportw(u_datal, data);
}
static WORD u_cmdrw(BYTE _index)
{
	outportb(u_cmd,   _index);
	return inportw(u_datal);
}


static BYTE u_irq_status(void)
{
	return inportb(u_status);
}

// pan 0 to 7 to 15
//
static void u_set_pan(BYTE voice, BYTE pan)
{
	u_voice_no(voice);
	u_cmdwb(0x0C, pan);
}

static void u_set_freq(BYTE voice, DWORD freq)
{
	WORD fc;

	fc = (WORD)( ((freq << 9) + (u_freq_value >> 1)) / u_freq_value);
	fc = fc << 1;
	u_voice_no(voice);
	u_cmdww(0x01, fc);
}

static void u_set_freq_stereo(BYTE voice)
{
	WORD fc;

	fc = 2 << 10;
	u_voice_no(voice);
	u_cmdww(0x01, fc);
}

static void u_set_volume(BYTE voice, WORD volume)
{
	u_voice_no(voice);
	u_cmdww(0x09, volume);
	u_delay();
	u_cmdww(0x09, volume);
}

#if 0
static void u_voice_start(BYTE voice, DWORD current, DWORD start, DWORD end,
						  int bits, int loop, int pan, DWORD freq, WORD volume)
{
	BYTE d0;

	u_voice_no(voice);

	u_set_pan(voice, pan);
	u_set_freq(voice, freq);
	u_set_volume(voice, volume);

	current = current << 9;
	start	= start   << 9;
	end 	= end	  << 9;
	u_cmdww(0x0A, (current >> 16) & 0xFFFF);
	u_cmdww(0x0B, current & 0xFFFF);
	u_cmdww(0x02, (start >> 16) & 0xFFFF);
	u_cmdww(0x03, start & 0xFFFF);
	u_cmdww(0x04, (end >> 16) & 0xFFFF);
	u_cmdww(0x05, end & 0xFFFF);

	d0 = 0x00;
	if(bits == 16)	  d0 |= 0x04;
	if(loop == _TRUE) d0 |= 0x08;

	u_cmdwb(0x00, d0);
}
#endif

static void u_16bit_stereo_voice_start(DWORD length, WORD volume)
{
	int d0;
	int voice = 0;
	DWORD current;
	DWORD start;
	DWORD end;

	u_prim_voice = voice;

	d0 = 0;
	while(d0 < 2){
		u_voice_no(voice + d0);
		current = d0;
		end 	= ((length + 31) * 2);
		start	= 31*2;
		current = current << 9;
		start	= start   << 9;
		end 	= end	  << 9;
		u_cmdww(0x0A, (current >> 16) & 0xFFFF);
		u_cmdww(0x0B, current & 0xFFFF);
		u_cmdww(0x02, (start >> 16) & 0xFFFF);
		u_cmdww(0x03, start & 0xFFFF);
		u_cmdww(0x04, (end >> 16) & 0xFFFF);
		u_cmdww(0x05, end & 0xFFFF);

		u_set_pan(voice + d0, (d0 == 0) ? 0 : 15);
		u_set_freq_stereo(voice + d0);
		u_set_volume(voice + d0, volume);

		d0 += 1;
	}

	w_enter_critical();
	u_voice_no(voice);
	u_cmdwb(0x00, 0x0C);
	u_voice_no(voice + 1);
	u_cmdwb(0x00, 0x0C);
	w_exit_critical();
}


static void u_voice_stop(BYTE voice)
{
	u_set_volume(voice, 0);
	u_voice_no(voice);
	u_cmdwb(0x00, 0x03);		// turn voice off
}


static DWORD u_get_current_location(BYTE voice)
{
	DWORD d0;
	DWORD d1;
	int d2;

	u_voice_no(voice);
	d2 = 0;
	while(d2 < 1024){
		d0	= (u_cmdrw(0x8A) & 0x1FFF) << 7;
		d0 |= u_cmdrw(0x8B) >> 9;
		d1	= (u_cmdrw(0x8A) & 0x1FFF) << 7;
		d1 |= u_cmdrw(0x8B) >> 9;
		if( (d1 - d0) == 0 || (d1 - d0) == 1 ) break;
		d2 += 1;
	}
	return d1;
}

static void u_upload(DWORD addr, BYTE data)
{
	static BYTE gusdramh = -1;

	if( ((addr >> 16) & 0x0F) != gusdramh ){
		gusdramh = (addr >> 16) & 0x0F;
		u_cmdwb(0x44, gusdramh);
	}
	u_cmdww(0x43, addr & 0xFFFF);
	outportb(u_base + 0x107, data);
}

static void u_set_dma_address(DWORD addr)
{
	if(g_dma > 3)
		addr = convert_to_16bit(addr);
	u_cmdww(0x42, (addr >> 4) & 0xFFFF);
}


/*	from GUSDK ROCK.C  */
static DWORD convert_to_16bit(DWORD address)
{
	DWORD hold_address;

	hold_address = address;

	/* Convert to 16 translated address. */
	address = address >> 1;

	/* Zero out bit 17. */
	address &= 0x0001ffffL;

	/* Reset bits 18 and 19. */
	address |= (hold_address & 0x000c0000L);

	return(address);
}





static volatile int u_dma_upload(DWORD addr, WORD count, DWORD gusaddr,
					int flag, DWORD addr2, WORD count2, DWORD gusaddr2)
{
	DWORD d0;

	d0 = 0;
	while(d0 < 65536*4){
		if(u_dma_busy_flag == _FALSE) break;
		u_delay();
		d0 += 1;
	}
	w_enter_critical();
	if(u_dma_busy_flag == _TRUE){
		u_abort_dma_upload();
		u_dma_busy_flag = _FALSE;
	}
	w_exit_critical();

	u_twoflag = flag;
	if(u_twoflag == _TRUE){
		d0 = gusaddr2 - (gusaddr2 & ~31);
		u_nextgusaddr = gusaddr2 & ~31;
		u_nextaddr	  = addr2  - d0;
		u_nextcount   = count2 + d0;
	}

	d0 = gusaddr - (gusaddr & ~31);
	gusaddr = gusaddr & ~31;
	w_enter_critical();
	u_dma_busy_flag = _TRUE;
	u_start_dma_upload(addr - d0, count + d0, gusaddr);
	w_exit_critical();
	return _TRUE;
}

static void u_start_dma_upload(DWORD addr, WORD count, DWORD gusaddr)
{
	BYTE d1;

	_dma_start(g_dma, addr, count, _FALSE, _FALSE);
	u_set_dma_address(gusaddr);
	d1 = 0x61;
	if(g_dma > 3) d1 |= 0x04;
	u_cmdwb(0x41, d1);
}

static void u_abort_dma_upload(void)
{
	BYTE d1;

	d1 = 0x60;
	if(g_dma > 3) d1 |= 0x04;
	u_cmdwb(0x41, d1);
	_dma_stop(g_dma);
	u_cmdrb(0x41);
}


static int u_gf1_irq_handler(void)
{
	BYTE d0;
	BYTE irq_status;

	tick += 1;

	while(1){
		irq_status = inportb(u_base + 0x006) & 0xE0;
		if(irq_status == 0) break;
		if( (irq_status & 0x80) != 0 ){
			d0 = u_cmdrb(0x41);
			if(u_twoflag == _TRUE){
				u_twoflag = _FALSE;
				u_start_dma_upload(u_nextaddr, u_nextcount, u_nextgusaddr);
			}else{
				u_dma_busy_flag = _FALSE;
			}
		}
		if( (irq_status & 0x60) != 0 ){
			d0 = u_cmdrb(0x8F);
		}
	}
	eoi(g_irq);
	return 0;
}




static void u_init(int base, DWORD freq)
{
	int voice_no;
	DWORD d0;
	BYTE d1;

	u_base	 = base;
	u_page	 = u_base + 0x102;
	u_cmd	 = u_base + 0x103;
	u_datal  = u_base + 0x104;
	u_datah  = u_base + 0x105;
	u_status = u_base + 0x006;
	u_dram	 = u_base + 0x107;

	u_cmdwb(0x4C, 0);				// reset
	u_delay();
	u_delay();
	u_cmdwb(0x4C, 1);				// enable
	u_delay();
	u_delay();

	u_cmdwb(0x41, 0);				// DMA off
	u_cmdwb(0x45, 0);				// disable TIMER irq
	u_cmdwb(0x49, 0);				// sampling control reg.

	if(freq == 44100){
		u_cmdwb(0x0E, (14-1) | 0xC0);	  // active voice 14 44100Hz
		u_freq_value = 44100;
	}else{
		u_cmdwb(0x0E, (28-1) | 0xC0);	  // active voice 28 22050Hz
		u_freq_value = 22050;
	}
	u_irq_status();

	u_cmdrb(0x41);
	u_cmdrb(0x49);
	u_cmdrb(0x8F);

	voice_no = 0;
	while(voice_no < 32){
		u_voice_stop(voice_no);
		u_voice_no(voice_no);
		u_cmdwb(0x0D, 0x03);		// turn ramp off
		voice_no += 1;
	}

	u_cmdrb(0x41);
	u_cmdrb(0x49);
	u_cmdrb(0x8F);
	u_cmdwb(0x4C, 0x07);
	u_delay();
	u_cmdwb(0x4C, 0x07);

	d1 = 0x00;
	d0 = 0;
	while(d0 < 65536*2){
		u_upload(d0, d1);
		d0 += 1;
	}

	outportb(u_base, 0x08);
}


static int get_ultrasnd(void)
{
	int midiirq;

	char *wsscfg = getenv("ULTRASND");
	if (wsscfg != NULL) {
		sscanf(wsscfg, "%x,%d,%d,%d,%d",
			&g_port, &g_dma, &g_hdma, &g_irq, &midiirq);
	}
	if( (g_port < 0) || (g_dma < 0) || (g_hdma < 0) || (g_irq < 0) ) return _FALSE;

	return _TRUE;
}




static int ultrasound_start(int rate_no)
{
	DWORD rate = 0;
	DWORD curr;

	switch(rate_no){
		case 2:
			rate = 22050;
			break;
		case 4:
			rate = 44100;
			break;
		default:
			rate = 44100;
	}
	g_device_sample_rate = rate;
	pcm_format = _16BITSTEREO;

	if( get_ultrasnd() == _FALSE ){
		error_mes = error_mes_ultrasnd_not_found;
		return _FALSE;
	}
	if(__dma_allocate_mem(_16BITSTEREO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}
	g_dmacnt_shift_count = 1;
	u_init(g_port, rate);
	unmask_irq(g_irq);
	install_irq_handler(g_irq, (void*)u_gf1_irq_handler);
	gf1_use_dma  = _TRUE;

	u_16bit_stereo_voice_start(SAMPLECNT, 0xFFFF);

	device_name = device_name_ultrasound;
	DMACTYPE = DMACTYPE_GF1;
	DEVICE	 = DEVICE_GF1;

	while(1){
		w_enter_critical();
		curr = u_get_current_location(u_prim_voice);
		w_exit_critical();
		if( curr > (32*4) ) break;
	}

	return _TRUE;
}

static void ultrasound_exit(void)
{
	int d0;

	if(DEVICE == DEVICE_GF1){
		d0 = 0;
		while(d0 < 2){
			u_voice_stop(d0);
			d0 += 1;
		}
		_dma_stop(g_dma);
		mask_irq(g_irq);
		restore_irq_handler();
		__dpmi_free_dos_memory(g_wss_dma_sel);
		u_init(g_port, 44100);
		DEVICE = DEVICE_NONE;
	}
}



/*	from Allegro sndscape.c  */
static int get_ini_config_entry(char *entry, char *dest, FILE *fp)
{
	char str[83];
	char tokstr[33];
	char *p;

	/* make a local copy of the entry, upper-case it */
	strcpy(tokstr, entry);
	strupr(tokstr);

	/* rewind the file and try to find it... */
	rewind(fp);

	for (;;) {
		/* get the next string from the file */
		fgets(str, 83, fp);
		if (feof(fp)) {
			fclose(fp);
			return -1;
		}

		/* properly terminate the string */
		for (p=str; *p; p++) {
			if (isspace(*p)) {
				*p = 0;
				break;
			}
		}

		/* see if it's an 'equate' string; if so, zero the '=' */
		p = strchr(str, '=');
		if (!p)
			continue;

		*p = 0;

		/* upper-case the current string and test it */
		strupr(str);

		if (strcmp(str, tokstr))
			continue;

		/* it's our string - copy the right-hand value to buffer */
		strcpy(dest, str+strlen(str)+1);
		break;
	}

	return 0;
}




/*	from Allegro sndscape.c  */
static int soundscape_get_init_config()
{
	FILE *fp = NULL;
	char str[78];
	char *ep;

	/* get the environment var and build the filename, then open it */
	if (!(ep = getenv("SNDSCAPE"))){
		error_mes = error_mes_sndscape_not_found;
		return _FALSE;
	}
	strcpy(str, ep);

	if (str[strlen(str)-1] == '\\')
		str[strlen(str)-1] = 0;

	strcat(str, "\\SNDSCAPE.INI");

	if (!(fp = fopen(str, "r"))){
		error_mes = error_mes_sndscape_ini_not_found;
		return _FALSE;
	}
   /* read all of the necessary config info ... */
   if (get_ini_config_entry("Product", str, fp)) {
	  fclose(fp);
	  error_mes = error_mes_error_in_sndscape_ini;
	  return _FALSE;
   }
#if 0
   /* if an old product name is read, set the IRQs accordingly */
   strupr(str);
   if (strstr(str, "SOUNDFX") || strstr(str, "MEDIA_FX"))
	  soundscape_irqset = rs_irqs;
   else
	  soundscape_irqset = ss_irqs;
   if (get_ini_config_entry("Port", str, fp)) {
	  fclose(fp);
	  return _FALSE;
   }

   soundscape_baseport = strtol(str, NULL, 16);
#endif

   if (get_ini_config_entry("WavePort", str, fp)) {
	  fclose(fp);
	  error_mes = error_mes_error_in_sndscape_ini;
	  return _FALSE;
   }

   g_port = strtol(str, NULL, 16) - 4;
#if 0
   if (get_ini_config_entry("IRQ", str, fp)) {
	  fclose(fp);
	  return _FALSE;
   }

   soundscape_midiirq = strtol(str, NULL, 10);

   if (soundscape_midiirq == 2)
	  soundscape_midiirq = 9;
#endif
   if (get_ini_config_entry("SBIRQ", str, fp)) {
	  fclose(fp);
	  error_mes = error_mes_error_in_sndscape_ini;
	  return _FALSE;
   }

   g_irq = strtol(str, NULL, 10);

   if (g_irq == 2)
	  g_irq = 9;

   if (get_ini_config_entry("DMA", str, fp)) {
	  fclose(fp);
	  error_mes = error_mes_error_in_sndscape_ini;
	  return _FALSE;
   }

   g_dma = strtol(str, NULL, 10);

   fclose(fp);
   return _TRUE;
}




static int detectES1370(void)
{
//
//	DPMI & PCI BIOS calling from ifsega2p.c. Thanks to SUZ.
//
	__dpmi_regs 	r;

	r.d.eax = 0x0000b101;						// PCI BIOS - INSTALLATION CHECK
	r.d.edi = 0x00000000;
	__dpmi_int(0x1a, &r);
	if( r.d.edx != 0x20494350 ){				// ' ICP'
		return _FALSE;
	}

	r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
	r.d.ecx = 0x00005000;						// device ID
	r.d.edx = 0x00001274;						// vendor ID
	r.d.esi = 0x00000000;						// device index
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		return _FALSE;
	}

	r.d.eax = 0x0000b10a;						// READ CONFIGURATION DWORD
												// BH = bus number
												// BL = device/function number
	r.d.edi = 0x00000010;						// register number
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		return _FALSE;
	}
	audiopci_iobase = r.d.ecx & ~0x3F;
	return _TRUE;
}


static int detectCMI8x38(void)
{
	__dpmi_regs 	r;

	r.d.eax = 0x0000b101;						// PCI BIOS - INSTALLATION CHECK
	r.d.edi = 0x00000000;
	__dpmi_int(0x1a, &r);
	if( r.d.edx != 0x20494350 ){				// ' ICP'
		return _FALSE;
	}

	while(1){
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000100;						// device ID
		r.d.edx = 0x000013F6;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ) break;

		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000101;						// device ID
		r.d.edx = 0x000013F6;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ) break;

		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000111;						// device ID
		r.d.edx = 0x000013F6;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ) break;

		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000101;						// device ID
		r.d.edx = 0x000010B9;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);

		if( r.h.ah == 0 ) break;
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00000111;						// device ID
		r.d.edx = 0x000010B9;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ) break;

		return _FALSE;
	}

	r.d.eax = 0x0000b10a;						// READ CONFIGURATION DWORD
												// BH = bus number
												// BL = device/function number
	r.d.edi = 0x00000010;						// register number
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		return _FALSE;
	}
	cmi8x38_iobase = r.d.ecx & ~0xFF;

	return _TRUE;
}


static int detectEV1935(void)
{
	__dpmi_regs 	r;

	r.d.eax = 0x0000b101;						// PCI BIOS - INSTALLATION CHECK
	r.d.edi = 0x00000000;
	__dpmi_int(0x1a, &r);
	if( r.d.edx != 0x20494350 ){				// ' ICP'
		return _FALSE;
	}

	r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
	r.d.ecx = 0x0000C935;						// device ID
	r.d.edx = 0x00001045;						// vendor ID
	r.d.esi = 0x00000000;						// device index
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		return _FALSE;
	}

	r.d.eax = 0x0000b10a;						// READ CONFIGURATION DWORD
												// BH = bus number
												// BL = device/function number
	r.d.edi = 0x00000014;						// register number
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		return _FALSE;
	}
	ev1935_iobase = r.d.ecx & ~0x7F;
	return _TRUE;
}

static int detectTrid4DWave(void)
{
	__dpmi_regs 	r;

	r.d.eax = 0x0000b101;						// PCI BIOS - INSTALLATION CHECK
	r.d.edi = 0x00000000;
	__dpmi_int(0x1a, &r);
	if( r.d.edx != 0x20494350 ){				// ' ICP'
		return _FALSE;
	}

	do{
		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00002000;						// device ID
		r.d.edx = 0x00001023;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ) break;					// DX found

		r.d.eax = 0x0000b102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00002001;						// device ID
		r.d.edx = 0x00001023;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		__dpmi_int(0x1a, &r);
		if( r.h.ah == 0 ) break;					// NX found

		r.d.eax = 0x0000B102;						// PCI BIOS - FIND PCI DEVICE
		r.d.ecx = 0x00007018;						// device ID
		r.d.edx = 0x00001039;						// vendor ID
		r.d.esi = 0x00000000;						// device index
		if( r.h.ah == 0 ) break;					// SiS Audio 7018 found

		return _FALSE;
	}while(0);

	r.d.eax = 0x0000b10a;						// READ CONFIGURATION DWORD
												// BH = bus number
												// BL = device/function number
	r.d.edi = 0x00000010;						// register number
	__dpmi_int(0x1a, &r);
	if( r.h.ah != 0 ){
		return _FALSE;
	}

	trid4dwave_iobase = r.d.ecx & ~0xFF;
	return _TRUE;
}





/*	from Allegro essaudio.c  */
static volatile int ess_is_dsp_ready_for_read(void)
{
   return (inportb(0x0E + g_port) & 0x80);
}

static volatile int ess_read_dsp(void)
{
   int x;

   for (x=0; x<0xffff; x++)
	  if (inportb(0x0E + g_port) & 0x80)
	 return inportb(0x0A + g_port);

   return -1;
}

static volatile int ess_write_dsp(unsigned char byte)
{
   int x;

   for (x=0; x<0xffff; x++) {
	  if (!(inportb(0x0C + g_port) & 0x80)) {
	 outportb(0x0C + g_port, byte);
	 return 0;
	  }
   }
   return -1;
}



static void ess_set_sample_rate(unsigned int rate)
{
   int tc;
   int divider;

   if (rate > 22094)
	  tc = 256 - 795500/rate;
   else
	  tc = 128 - 397700/rate;

   rate = (rate*9)/20;
   divider = 256 - 7160000/(rate*82);

   ess_write_dsp(0xA1);
   ess_write_dsp(tc);

   ess_write_dsp(0xA2);
   ess_write_dsp(divider);
}


static int ess_read_dsp_version(void)
{
	int ess_hw_ver;

   if (_sb_reset_dsp(1) != 0) {
	  ess_hw_ver = -1;
   }else {
	  int major=0, minor=0;
	  int i;

	  ess_write_dsp(0xE7);

	  for (i=0; i<240; i++) {
	 if (ess_is_dsp_ready_for_read()) {
		if (!major)
		   major = ess_read_dsp();
		else
		   minor = ess_read_dsp();
	 }
	  }

	  if ((major==0x68) && ((minor&0xF0)==0x80)) {
	 if ((minor&0x0F) >= 0xB)
		ess_hw_ver = 0x1868;
	 else if ((minor&0x0F) >= 8)
		ess_hw_ver = 0x1688;
	 else
		ess_hw_ver = 0x0688;

	 return ess_hw_ver;
	  }
   }
   return -1;
}


static void ess_play_buffer(int size)
{
	int value;

	ess_write_dsp(0xA4);
	ess_write_dsp((-size)&0xFF);
	ess_write_dsp(0xA5);
	ess_write_dsp((-size)>>8);

	ess_write_dsp(0xC0);
	ess_write_dsp(0xB8);
	value = ess_read_dsp() | 0x05;
	ess_write_dsp(0xB8);
	ess_write_dsp(value);
}



static int ess_start(int rate_no)
{
	int value;
	int rate = 22097;

	switch(rate_no){
		case 1:
			rate = 11047;
			break;
		case 2:
			rate = 22097;
			break;
		case 3:
			rate = 33145;
			break;
		case 4:
			rate = 44194;
			break;
		case 5:
			rate = 49718;
			break;
		case 6:
			rate = 61192;
			break;
		default:
			rate = 22097;
	}

	if( get_blaster() == _FALSE ){
		error_mes = error_mes_blaster_not_found;
		return _FALSE;
	}
	if( ess_read_dsp_version() < 0 ){
		error_mes = error_mes_ess_audiodrive_not_found;
		return _FALSE;
	}
	g_device_sample_rate = rate;
	pcm_format = _16BITSTEREO;

	if(__dma_allocate_mem(_16BITSTEREO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}
	/* switch to AudioDrive extended mode */
	_sb_reset_dsp(0x03);
	ess_write_dsp(0xC6);

	ess_set_sample_rate(rate);

	ess_write_dsp(0xB8);
	ess_write_dsp(0x04);

	ess_write_dsp(0xC0);
	ess_write_dsp(0xA8);
	value = ess_read_dsp() & ~3;

	/* 16 bit stereo */
	value |= 0x01;
	ess_write_dsp(0xA8);
	ess_write_dsp(value);
	ess_write_dsp(0xB6);
	ess_write_dsp(0x00);
	ess_write_dsp(0xB7);
	ess_write_dsp(0x71);
	ess_write_dsp(0xB7);
	ess_write_dsp(0xBC);

	/* demand mode (4 bytes/request) */
	ess_write_dsp(0xB9);
	ess_write_dsp(2);

	ess_write_dsp(0xC0);
	ess_write_dsp(0xB1);
//	  value = (ess_read_dsp() & 0x0F) | 0x50;
	value = (ess_read_dsp() & 0x0F) | 0x10;
	ess_write_dsp(0xB1);
	ess_write_dsp(value);

	ess_write_dsp(0xC0);
	ess_write_dsp(0xB2);
	value = (ess_read_dsp() & 0x0F) | 0x50;
	ess_write_dsp(0xB2);
	ess_write_dsp(value);

	_sb_voice(_TRUE);
	_dma_start(g_dma, g_wss_dma_addr, g_dma_buff_size, _TRUE, _FALSE);
	ess_play_buffer(g_dma_buff_size);
	_sb_dac_level(0xFF);

	device_name = device_name_ess_audiodrive;
	DMACTYPE = DMACTYPE_NORMAL;
	DEVICE	 = DEVICE_ESS;

	return _TRUE;
}

static void ess_exit(void)
{
	if(DEVICE == DEVICE_ESS){
		/* halt sound output */
		_sb_voice(_FALSE);
		/* stop dma transfer */
		_dma_stop(g_dma);
		_sb_reset_dsp(1);
		__dpmi_free_dos_memory(g_wss_dma_sel);
		DEVICE = DEVICE_NONE;
	}
}



static int eternal_silence_start(int rate_no)
{
	if(__dma_allocate_mem(_16BITSTEREO) == _FALSE){
		error_mes = error_mes_dma_allocate_mem_failed;
		return _FALSE;
	}
	es_tick_per_hz = TICKS_PER_SEC / rate_no;
	es_remain = 0;
	es_prev = ticker();
	es_count = 0;
	g_device_sample_rate = rate_no;
	device_name = device_name_eternal_silence;
	DMACTYPE = DMACTYPE_SILENCE;
	DEVICE = DEVICE_SILENCE;
	return _TRUE;
}

static void eternal_silence_exit(void)
{
	if(DEVICE == DEVICE_SILENCE){
		__dpmi_free_dos_memory(g_wss_dma_sel);
		DEVICE = DEVICE_NONE;
	}
}


static DWORD eternal_silence_current_pos(void)
{
	TICKER curr;

	curr = ticker();
	es_remain += curr - es_prev;
	es_prev = curr;
	while(es_remain >= es_tick_per_hz){
		es_remain -= es_tick_per_hz;
		es_count -= 1;
	}
	es_count = es_count & SAMPLECNTMASK;
	return es_count << 2;						// _16BITSTEREO 
}





static DWORD g_prev_play_cursor = 0;
static DWORD g_write_cursor = 0;
static DWORD g_latency	= 48000/30;
static float g_latencym = 2.2;
static DWORD g_dma_average_cnt = (48000/60) << 8;
static int	 g_dma_dt = 0;
static int	 g_dma_overflow  = 0;
static int	 g_dma_underflow = 0;
#define DMA_AVERAGE 			256
#define DMA_AVERAGE_MASK		0xFF
#define DMA_AVERAGE_SHIFT_COUNT 8

static DWORD g_dma_remainder = 0;
static long  mixing_buff[SAMPLECNT*2];
static DWORD g_current_req = 0;
static DWORD g_next_req = 0;
static int	 g_master_volume = 256;


void w_set_watermark(float latency, DWORD samples_per_frame)
{
	if(DEVICE == DEVICE_NONE) return;

	if(latency < 1.0) latency = 1.0;
	g_latencym = latency;
	g_latency = samples_per_frame * g_latencym;
	g_dma_average_cnt = samples_per_frame << DMA_AVERAGE_SHIFT_COUNT;
	w_reset_write_cursor(0);

	w_clear_buffer();
}


void w_set_master_volume(int volume)
{
	g_master_volume = volume;
}




DWORD w_get_current_req(void)
{
	if(DEVICE == DEVICE_NONE) return 0;
	return g_current_req;
}

DWORD w_get_next_req(void)
{
	if(DEVICE == DEVICE_NONE) return 0;
	return g_next_req;
}



static void calc_next_req(void)
{
	if(DEVICE == DEVICE_NONE) return;

	g_dma_remainder += g_dma_average_cnt;
	g_dma_remainder += g_dma_dt;
	g_dma_dt = 0;
	g_current_req = g_next_req;
	g_next_req = g_dma_remainder >> DMA_AVERAGE_SHIFT_COUNT;
	g_dma_remainder = g_dma_remainder & DMA_AVERAGE_MASK;

	if(g_current_req == 0 || g_current_req > SAMPLECNT) g_current_req = 1;
	if(g_next_req	 == 0 ||	g_next_req > SAMPLECNT) g_next_req = 1;
}


void w_reverse_stereo(int flag)
{
	stereo_reverse_flag = (flag) ? _TRUE : _FALSE;
}


void w_lock_mixing_buffer(int currentsamplecount)
{
	DWORD d0;

	if(DEVICE == DEVICE_NONE) return;

	if(currentsamplecount != 0)
		g_current_req = currentsamplecount;

	if(g_current_req > SAMPLECNT) return;

	d0 = 0;
	while(d0 < g_current_req){
		mixing_buff[(d0*2) + 0] = 0;
		mixing_buff[(d0*2) + 1] = 0;
		d0 += 1;
	}
}


void w_mixing8(char data[], DWORD length, int leftvol, int rightvol)
{
	DWORD dt;
	DWORD d0;
	int d1;
	long d2;
	int leftindex  = 0;
	int rightindex = 1;

	if(stereo_reverse_flag == _TRUE){
		leftindex  = 1;
		rightindex = 0;
	}

	if(DEVICE == DEVICE_NONE) return;
	if(g_current_req > SAMPLECNT) return;

	dt = (length << 16) / g_current_req;
	d0 = 0;
	d1 = 0;
	while(d1 < g_current_req){
		d2 = (long)data[d0 >> 16];
		d2 = d2 << 8;
		mixing_buff[(d1*2) + leftindex ] += (d2 * leftvol)	/ 256;
		mixing_buff[(d1*2) + rightindex] += (d2 * rightvol) / 256;
		d0 += dt;
		d1 += 1;
	}
}

void w_mixing(short data[], DWORD length, int leftvol, int rightvol)
{
	DWORD dt;
	DWORD d0;
	int d1;
	long d2;
	int leftindex  = 0;
	int rightindex = 1;

	if(stereo_reverse_flag == _TRUE){
		leftindex  = 1;
		rightindex = 0;
	}

	if(DEVICE == DEVICE_NONE) return;
	if(g_current_req > SAMPLECNT) return;

	dt = (length << 16) / g_current_req;
	d0 = 0;
	d1 = 0;
	while(d1 < g_current_req){
		d2 = (long)data[d0 >> 16];
		mixing_buff[(d1*2) + leftindex ] += (d2 * leftvol)	/ 256;
		mixing_buff[(d1*2) + rightindex] += (d2 * rightvol) / 256;
		d0 += dt;
		d1 += 1;
	}
}

void w_mixing_stereo(short data[], DWORD length, int leftvol, int rightvol)
{
	DWORD dt;
	DWORD d0;
	int d1;
	long left;
	long right;
	int leftindex  = 0;
	int rightindex = 1;

	if(stereo_reverse_flag == _TRUE){
		leftindex  = 1;
		rightindex = 0;
	}

	if(DEVICE == DEVICE_NONE) return;
	if(g_current_req > SAMPLECNT) return;

	dt = (length << 16) / g_current_req;
	d0 = 0;
	d1 = 0;
	while(d1 < g_current_req){
		left  = (long)data[((d0 >> 16) * 2)];
		right = (long)data[((d0 >> 16) * 2) + 1];
		mixing_buff[(d1*2) + leftindex ] += (left  * leftvol)  / 256;
		mixing_buff[(d1*2) + rightindex] += (right * rightvol) / 256;
		d0 += dt;
		d1 += 1;
	}
}



void w_unlock_mixing_buffer(void)
{
	int d0;
	long d1;
	WORD d2;
	DWORD d3;
	BYTE d4;
	DWORD start;
	DWORD end;
	DWORD start2;
	DWORD end2;

	if(DEVICE == DEVICE_NONE) return;

	if( (DEVICE == DEVICE_GF1) && (gf1_use_dma == _FALSE) ){
		d0 = 0;
		while(d0 < g_current_req){
			g_write_cursor = g_write_cursor & SAMPLECNTMASK;
			d1	= ((mixing_buff[(d0*2) + 0] * g_master_volume)/256);
			if(d1 >  32767) d1 =  32767;
			if(d1 < -32768) d1 = -32768;
			d3	= d1 & 0xFFFF;
			d1	= ((mixing_buff[(d0*2) + 1] * g_master_volume)/256);
			if(d1 >  32767) d1 =  32767;
			if(d1 < -32768) d1 = -32768;
			d3 |= d1 << 16;
			u_upload( (32*4) + (g_write_cursor*4) + 0,	(d3 >>	0) & 0xFF);
			u_upload( (32*4) + (g_write_cursor*4) + 1,	(d3 >>	8) & 0xFF);
			u_upload( (32*4) + (g_write_cursor*4) + 2,	(d3 >> 16) & 0xFF);
			u_upload( (32*4) + (g_write_cursor*4) + 3,	(d3 >> 24) & 0xFF);
			if(g_write_cursor == SAMPLECNTMASK){
				u_upload( (31*4) + 0,  (d3 >>  0) & 0xFF);
				u_upload( (31*4) + 1,  (d3 >>  8) & 0xFF);
				u_upload( (31*4) + 2,  (d3 >> 16) & 0xFF);
				u_upload( (31*4) + 3,  (d3 >> 24) & 0xFF);
			}
			g_write_cursor += 1;
			d0 += 1;
		}
	}else{
		start = -1;
		_farsetsel(_dos_ds);
		d0 = 0;
		while(d0 < g_current_req){
			g_write_cursor = g_write_cursor & SAMPLECNTMASK;
			if(pcm_format == _16BITSTEREO){
				d1	= ((mixing_buff[(d0*2) + 0] * g_master_volume)/256);
				if(d1 >  32767) d1 =  32767;
				if(d1 < -32768) d1 = -32768;
				d3	= d1 & 0xFFFF;
				d1	= ((mixing_buff[(d0*2) + 1] * g_master_volume)/256);
				if(d1 >  32767) d1 =  32767;
				if(d1 < -32768) d1 = -32768;
				d3 |= d1 << 16;
				_farnspokel(g_wss_dma_addr + (g_write_cursor * 4), d3);
			}else if(pcm_format == _8BITSTEREO){
				d1	= ((mixing_buff[(d0*2) + 0] * g_master_volume)/256);
				if(d1 > _8bitconvert_max) d1 = _8bitconvert_max;
				if(d1 < _8bitconvert_min) d1 = _8bitconvert_min;
				d2	= ((d1 + _8bitconvert_sign) >> _8bitconvert_shiftcount) & 0xFF;
				d1	= ((mixing_buff[(d0*2) + 1] * g_master_volume)/256);
				if(d1 > _8bitconvert_max) d1 = _8bitconvert_max;
				if(d1 < _8bitconvert_min) d1 = _8bitconvert_min;
				d2 |= (((d1 + _8bitconvert_sign) >> _8bitconvert_shiftcount) & 0xFF) << 8;
				_farnspokew(g_wss_dma_addr + (g_write_cursor * 2), d2);
			}else if(pcm_format == _8BITMONO){
				d1	= ((mixing_buff[(d0*2) + 0] * g_master_volume)/256);
				d1 += ((mixing_buff[(d0*2) + 1] * g_master_volume)/256);
				d1 = d1 / 2;
				if(d1 > _8bitconvert_max) d1 = _8bitconvert_max;
				if(d1 < _8bitconvert_min) d1 = _8bitconvert_min;
				d4	= ((d1 + _8bitconvert_sign) >> _8bitconvert_shiftcount) & 0xFF;
				_farnspokeb(g_wss_dma_addr + (g_write_cursor * 1), d4);
			}
			if(start == -1) start = g_write_cursor;
			g_write_cursor += 1;
			d0 += 1;
		}
		end = g_write_cursor;
		if( (DEVICE == DEVICE_GF1) && (gf1_use_dma == _TRUE) ){
			if(start <= end){
				start = start * 4;
				end   = end * 4;
				u_dma_upload(g_wss_dma_addr + start, end - start, start + (32*4),
						_FALSE, 0, 0, 0);
			}else{
				d3 = _farnspeekl(g_wss_dma_addr + (SAMPLECNTMASK * 4) );
				u_upload( (31*4) + 0,  (d3 >>  0) & 0xFF);
				u_upload( (31*4) + 1,  (d3 >>  8) & 0xFF);
				u_upload( (31*4) + 2,  (d3 >> 16) & 0xFF);
				u_upload( (31*4) + 3,  (d3 >> 24) & 0xFF);

				start2 = 0;
				end2 = end * 4;
				start = start * 4;
				end  = SAMPLECNT * 4;
				u_dma_upload(g_wss_dma_addr + start, end - start, start + (32*4),
						_TRUE, g_wss_dma_addr + start2, end2 - start2, start2 + (32*4));
			}
		}
	}
}

void w_set_8bitpcm_shift_count(int count)
{
	_8bitconvert_max  = _8bitconvert_max  >> (8 - count);
	_8bitconvert_min  = _8bitconvert_min  >> (8 - count);
	_8bitconvert_sign = _8bitconvert_sign >> (8 - count);
	_8bitconvert_shiftcount = 8 - (8 - count);
}

void w_set_sb_cursor_offset(int offset)
{
	sb_cursor_offset = offset & SAMPLECNTMASK;
}


static DWORD _dma_counter(void)
{
	DWORD d0 = 0;
	DWORD d1;
	int limit;
	static DWORD dmac_sbirq_prev = 0;
	static int ticker_flag = 0;
	static TICKER prev = 0;

	if(DEVICE == DEVICE_NONE) return 0;

	switch(DMACTYPE){
		case DMACTYPE_NORMAL:
			w_enter_critical();
			d0 = _dma_todo(g_dma);
			w_exit_critical();
			break;

		case DMACTYPE_SILENCE:
			d0 = eternal_silence_current_pos();
			break;

		case DMACTYPE_GF1:
			w_enter_critical();
			d0 = (SAMPLECNT*2) - (u_get_current_location(u_prim_voice) - (31*2));
			w_exit_critical();
			break;

		case DMACTYPE_CMI8x38:
			limit = 1024;
			w_enter_critical();
			while(limit > 0){
				d0 = inportw(cmi8x38_iobase + 0x1E);
				d1 = inportw(cmi8x38_iobase + 0x1E);
				if(d0 == d1) break;
				limit -= 1;
			}
			w_exit_critical();
			d0 = d0 * 2;
			break;

		case DMACTYPE_EV1935:
			limit = 1024;
			w_enter_critical();
			while(limit > 0){
				d0	= inportb(ev1935_iobase + 4);
				d0 |= inportb(ev1935_iobase + 5) << 8;
				d1	= inportb(ev1935_iobase + 4);
				d1 |= inportb(ev1935_iobase + 5) << 8;
				if(d0 == d1) break;
				limit -= 1;
			}
			w_exit_critical();
			break;

		case DMACTYPE_4DWAVE:
			limit = 1024;
			w_enter_critical();
			while(limit > 0){
				d0	= inportb(trid4dwave_iobase + 4);
				d0 |= inportb(trid4dwave_iobase + 5) << 8;
				d1	= inportb(trid4dwave_iobase + 4);
				d1 |= inportb(trid4dwave_iobase + 5) << 8;
				if(d0 == d1) break;
				limit -= 1;
			}
			w_exit_critical();
			break;

		case DMACTYPE_SB201IRQ:
			d0 = sb_interrupt_driven_dma_position;
			break;

		case DMACTYPE_SB100IRQ:
			d0 = sb_interrupt_driven_dma_position;
			if(ticker_flag == 0){
				if(d0 == dmac_sbirq_prev){
					ticker_flag = 1;
					prev = ticker();
				}else{
					dmac_sbirq_prev = d0;
				}
			}else{
				if(d0 == dmac_sbirq_prev){
					if( (ticker() - prev) > (TICKS_PER_SEC / 120) ){
						ticker_flag = 0;
						w_enter_critical();
						sb100_interrupt_driven_interrupt();
						w_exit_critical();
					}
				}else{
					dmac_sbirq_prev = d0;
					ticker_flag = 0;
				}
			}
			break;

		default:
			d0 = 0;
	}
	return d0;
}



static DWORD get_played_sample_count(void)
{
	DWORD curr;
	DWORD d0;

	if(DEVICE == DEVICE_NONE) return 0;

	curr = w_get_play_cursor();
	d0 = w_calc_distance(curr, g_prev_play_cursor);
	g_prev_play_cursor = curr;

	return d0;
}





DWORD w_get_buffer_size(void)
{
	return SAMPLECNT;
}


DWORD w_get_play_cursor(void)
{
	return (SAMPLECNT - 1) - (_dma_counter() >> g_dmacnt_shift_count);
}

DWORD w_get_write_cursor(void)
{
	return g_write_cursor;
}

void w_set_write_cursor(DWORD position)
{
	g_write_cursor = w_calc_position(position, 0);
}



void w_reset_watermark(void)
{
	w_reset_write_cursor(0);
}

void w_reset_watermark_ex(DWORD samplecount)
{
	w_reset_write_cursor(samplecount);
}

void w_reset_write_cursor(DWORD samplecount)
{
	DWORD current;

	if(DEVICE == DEVICE_NONE) return;

	current 		   = w_get_play_cursor();
	g_prev_play_cursor = current;

	if(samplecount <= g_latency){
		samplecount = g_latency - samplecount;
	}else{
		samplecount = 0;
	}
	w_set_write_cursor( w_calc_position(current, samplecount) );

	g_dma_remainder = 0;
	g_dma_dt = 0;
	calc_next_req();
	calc_next_req();
}


DWORD w_calc_distance(DWORD cursor1, DWORD cursor2)
{
	return (cursor1 - cursor2) & SAMPLECNTMASK;
}

DWORD w_calc_position(DWORD cursor1, DWORD cursor2)
{
	return (cursor1 + cursor2) & SAMPLECNTMASK;
}


DWORD w_get_requested_sample_count(void)
{
	DWORD d0;

	d0 = w_get_latency();
	if(d0 > w_get_buffer_size()/2){
		w_reset_watermark();
		return 0;
	}
	if(d0 >= g_latency) return 0;
	return g_latency - d0;
}


DWORD w_get_latency(void)
{
	DWORD d0;

	if(DEVICE == DEVICE_NONE)
		d0 = 0;
	else
		d0 = w_calc_distance(w_get_write_cursor(), w_get_play_cursor());

	return d0;
}

int w_get_watermark_status(void)
{
	DWORD d0;
	int result;

	if(DEVICE == DEVICE_NONE) return 0;

	d0 = w_get_latency();

	if(d0 >= (DWORD)(g_latency*2.5)){
		result = -2;							// overrun
	}else if(d0 >= (DWORD)(g_latency*1.5)){
		result = 2; 							// full
	}else if(d0 >= g_latency){
		result = 1; 							// good
	}else if(d0 >= (g_dma_average_cnt >> 8)){
		result = 0; 							// ok
	}else{
		result = -1;							// lack
	}

	return result;
}


static DWORD ofdt = 0;
static DWORD ufdt = 0;
static int dma_dt = 0;

DWORD w_adjust_latency_for_vsync(void)
{
	DWORD d0;

	if(DEVICE == DEVICE_NONE) return 0;

	d0 = w_calc_distance(w_get_write_cursor(), w_get_play_cursor());
	if( d0 >= (g_latency + 1) ){
		ofdt = d0 - g_latency;
		g_dma_overflow	+= 1;
		g_dma_underflow  = 0;
	}else if( d0 <= (g_latency - 1) ){
		ufdt = g_latency - d0;
		g_dma_overflow	 = 0;
		g_dma_underflow += 1;
	}else{
		g_dma_overflow	 = 0;
		g_dma_underflow  = 0;
	}
	if(g_dma_overflow > 16)
		g_dma_overflow = 16;
	if(g_dma_underflow > 16)
		g_dma_underflow = 16;
	ofdt = ofdt  * (g_dma_overflow	& 0xFE);
	ufdt = ufdt  * (g_dma_underflow & 0xFE);
	if(ofdt > (g_device_sample_rate  >> 5))
		ofdt = (g_device_sample_rate  >> 5);
	if(ufdt > (g_device_sample_rate  >> 5))
		ufdt = (g_device_sample_rate  >> 5);

	g_dma_dt = ufdt - ofdt;
	dma_dt = g_dma_dt;			// for debug

	calc_next_req();

	return d0;
}




float w_calc_samples_per_vsync(void (*__vsync)(void), int vsync_count)
{
	DWORD d0;
	DWORD result[2];
	int d1;
	int count;
	int limit;
	int d7;

	if(DEVICE == DEVICE_NONE) return 0;
	limit = 16;
	while(limit > 0){
		d7 = 0;
		while(d7 < 2){
			d1 = 0;
			while(d1 < 4){
				count = 0;
				while(count < vsync_count){
					(*__vsync)();
					count += 1;
				}
				get_played_sample_count();
				d1 += 1;
			}
			d0 = 0;
			d1 = 0;
			while(d1 < (256/8)){
				count = 0;
				while(count < vsync_count){
					(*__vsync)();
					count += 1;
				}
				d0 += get_played_sample_count();
				d1 += 1;
			}
			result[d7] = d0;
			d7 += 1;
		}
		if(result[0] > result[1]){
			d0 = result[0] - result[1];
		}else{
			d0 = result[1] - result[0];
		}
		if(d0 < 16) break;
		limit -= 1;
	}

	d0 = (result[0] + result[1]) * 4;
	g_latency = (d0 * g_latencym) / 256;
	g_dma_average_cnt = d0;
	calc_next_req();
	calc_next_req();

	return (float)d0/256;
}




void w_clear_buffer(void)
{
	int d0;
	BYTE d1;

	if(DEVICE == DEVICE_NONE) return;

	d1 = 0x80;
	if(pcm_format == _16BITSTEREO){
		d1 = 0x00;
	}
	_farsetsel(_dos_ds);
	d0 = 0;
	while(d0 < g_dma_buff_size){
		_farnspokeb(g_wss_dma_addr + d0, d1);
		d0 += 1;
	}

	if(DEVICE == DEVICE_GF1){
		u_set_volume(u_prim_voice + 0, 0);
		u_set_volume(u_prim_voice + 1, 0);

		d1 = 0x00;
		d0 = 0;
		while(d0 < 65536*2){
			u_upload(d0, d1);
			d0 += 1;
		}
		u_set_volume(u_prim_voice + 0, 0xFFFF);
		u_set_volume(u_prim_voice + 1, 0xFFFF);
	}
}





DWORD w_get_nominal_sample_rate(void)
{
	if(DEVICE == DEVICE_NONE) return 0;
	return g_device_sample_rate;
}

char *w_get_device_name(void)
{
	if(DEVICE == DEVICE_NONE) return NULL;
	return device_name;
}




int w_sound_device_init(int device_no, int rate_no)
{
	int result;

	if(DEVICE != DEVICE_NONE){
		return _FALSE;
	}

	if(rate_no < 0)
		rate_no = 22050;
	if(rate_no > 64000)
		rate_no = 64000;

	if(device_no != 0){
		if(rate_no >= 7){
			if(rate_no < 20000){
				rate_no = 1;
			}else if(rate_no < 31500){
				rate_no = 2;
			}else if(rate_no < 40000){
				rate_no = 3;
			}else if(rate_no < 46000){
				rate_no = 4;
			}else if(rate_no < 60000){
				rate_no = 5;
			}else{
				rate_no = 6;
			}
		}
	}

	switch(device_no){
		case 0:
			result = eternal_silence_start(rate_no);
			break;
		case 1:
			result = sb_auto_detect_start(rate_no);
			break;
		case 4:
			result = ultramax_start(rate_no);
			break;
		case 5:
			result = ultrasound_start(rate_no);
			break;
		case 6:
			result = wss_start(rate_no);
			break;
		case 7:
			result = soundscape_start(rate_no);
			break;
		case 8:
			result = ess_start(rate_no);
			break;
		case 9:
			result = sbpro_interrupt_driven_start(rate_no);
			break;
		case 10:
			result = sb201_interrupt_driven_start(rate_no);
			break;
		case 11:
			result = sb100_interrupt_driven_start(rate_no);
			break;
		case 12:
			result = sb201_start(rate_no);
			break;
		case 13:
			result = sbpro_start(rate_no);
			break;
		case 14:
			result = sb16_start(rate_no);
			break;
		case 15:
			result = sbpro_ex_start(rate_no);
			break;
		case 16:
			result = sb16_ex_start(rate_no);
			break;
		case 17:
			result = cmi8x38_as_sb16_start(rate_no);
			break;
		case 18:
			result = es1370_as_soundscape_start(rate_no);
			break;
		case 19:
			result = ev1935_as_sbpro_start(rate_no);
			break;
		case 20:
			result = ev1935_as_wss_start(rate_no);
			break;
		case 21:
			result = trid4dwave_as_sb16_start(rate_no);
			break;
		default:
			result = _FALSE;
	}

	w_set_watermark(2.2, 1200);

	return result;
}

void w_sound_device_exit(void)
{
	w_clear_buffer();
	eternal_silence_exit();
	wss_exit();
	sb_exit();
	ultrasound_exit();
	ess_exit();
	g_port = -1;
	g_irq  = -1;
	g_dma  = -1;
	g_hdma = -1;
}



void vga_vsync(void)
{
	w_enter_critical();
	while( (inportb(0x3da) & 0x08) != 0 );
	while( (inportb(0x3da) & 0x08) == 0 );
	w_exit_critical();
}





DWORD w_get_actual_sample_rate(void)
{
	DWORD d0;
	DWORD result[2];
	int d1;
	int d7;
	int limit;
	TICKER prev;
	TICKER curr;

	if(DEVICE == DEVICE_NONE) return 0;

	w_set_watermark(2.0, w_get_nominal_sample_rate()/60);

	prev = ticker();
	while(1){
		if( (ticker() - prev) >= TICKS_PER_SEC/2 ) break;
		get_played_sample_count();
	}

	limit = 16;
	while(limit > 0){
		d7 = 0;
		while(d7 < 2){
			d0 = 0;
			d1 = 65536;
			get_played_sample_count();
			while(d1 > 0){
				if(get_played_sample_count != 0) break;
				d1 -= 1;
			}
			prev = ticker();
			while(1){
				d0 += get_played_sample_count();
				curr = ticker();
				if( (curr - prev) >= TICKS_PER_SEC/2 ) break;
			}
			result[d7] = d0;
			d7 += 1;
		}
		if(result[0] > result[1]){
			d0 = result[0] - result[1];
		}else{
			d0 = result[1] - result[0];
		}
		if(d0 <= 8) break;
		limit -= 1;
	}
	actual_sample_rate = result[0] + result[1];
	return actual_sample_rate;
}


char *w_get_error_message(void)
{
	return error_mes;
}






/////////////////////////////////////////////////////////////////////
// main



#if 0




static double sin1dt;
static double sin2ldt;
static double sin2rdt;
static double sin1t;
static double sin1t2;
static double sin2lt;
static double sin2rt;


static void sin_stream_init(int rate)
{
	sin1dt	= 2.0 * M_PI * 880.0 / rate;
	sin2ldt = 2.0 * M_PI * 441.5 / rate;
	sin2rdt = 2.0 * M_PI * 438.5 / rate;
	sin1t	= 0;
	sin1t2	= 0;
	sin2lt	= 0;
	sin2rt	= 0;
}

static short sin_stream1(void)
{
	short d0;

	sin1t2 += 0.00005;
	if(sin1t2 > 2*M_PI) sin1t2 -= 2*M_PI;
	d0 = (short)(  16384 * sin(sin1t += (sin1dt + (sin1dt/4)*sin(sin1t2)))	);
	return d0;
}

static short sin_stream2l(void)
{
	short d0;

	d0 = (short)(16384 * sin(sin2lt += sin2ldt));
	return d0;
}

static short sin_stream2r(void)
{
	short d0;

	d0 = (short)(16384 * sin(sin2rt += sin2rdt));
	return d0;
}



#define NORMAL							 1
#define VSYNC							 2

#define FRAMES_PER_SEC	60

int main()
{
	int d0;
	DWORD d1;
	int actual_sample_rate;
	short a0[65536];
	short a1[65536*2];
	DWORD samples_this_frame = 0;
	DWORD samples_left_over;
	DWORD samples_per_frame;
	int mode;
	int use_joystickbutton = _TRUE;

	mode = NORMAL;
//	  mode = VSYNC;

	if( w_sound_device_init(1, 22050) == _FALSE){
		printf("%s\n", w_get_error_message() );
		return -1;
	}

	printf("%s	", w_get_device_name() );
	printf("nominal rate : %d Hz\n", w_get_nominal_sample_rate());

	actual_sample_rate = w_get_actual_sample_rate();
	printf("  actual rate  : %d Hz\n", actual_sample_rate);

	sin_stream_init(actual_sample_rate);

	samples_this_frame = actual_sample_rate / FRAMES_PER_SEC;
	w_set_watermark(2.2, samples_this_frame);

	if(mode == VSYNC){
		samples_this_frame = (int)w_calc_samples_per_vsync(vga_vsync, 1);
		printf("samples per vsync : %d\n", samples_this_frame);
	}

	if(mode == NORMAL){
		samples_per_frame = (actual_sample_rate << 12) / FRAMES_PER_SEC;
		samples_left_over = 0;
	}

	while(1){
		if(mode == NORMAL){
			samples_left_over += samples_per_frame;
			samples_this_frame = (DWORD)(samples_left_over >> 12);
			samples_left_over  = samples_left_over & 0xFFF;
		}

		d0 = 0;
		while(d0 < samples_this_frame){
			a0[d0] = sin_stream1();
			d0 += 1;
		}
		d0 = 0;
		while(d0 < samples_this_frame){
			a1[(d0 * 2) + 0] = sin_stream2l();
			a1[(d0 * 2) + 1] = sin_stream2r();
			d0 += 1;
		}

		printf("samples : %d,  ", samples_this_frame);

		if(mode == NORMAL){
			if(w_get_watermark_status() == -2){
				w_reset_watermark();
				printf("\n reset watermark \n\n");
			}
		}

		if(mode == NORMAL || mode == VSYNC){
			w_lock_mixing_buffer(samples_this_frame);
		}else{
			w_lock_mixing_buffer(0);
		}

		w_mixing(a0, samples_this_frame, 0, 256);
		w_mixing_stereo(a1, samples_this_frame, 256, 256);
		w_unlock_mixing_buffer();

		if(mode == VSYNC){
			samples_this_frame = w_get_next_req();
		}

		if(mode == NORMAL){
			while(1){
				d0 = w_get_watermark_status();
				if(d0 == -1 || d0 == 0) break;
				if(d0 == -2) {
					w_reset_watermark();
					printf("\n reset watermark \n\n");
					break;
				}
			}
			printf("latency:%5d, play:%5d, write:%5d \n",
						w_get_latency(),
						w_get_play_cursor(), w_get_write_cursor());
		}else{
			vga_vsync();
			d0 = w_get_watermark_status();
			if(d0 == -1 || d0 == -2){
				w_reset_watermark();
				printf("\n reset watermark \n\n");
			}
			d1 = w_adjust_latency_for_vsync();
			printf("latency:%5d, play:%5d, write:%5d \n",
						w_get_latency(),
						w_get_play_cursor(), w_get_write_cursor());
			printf("over %5d, under %5d, ofdt %5d, ufdt %5d, dt %5d\n",
				g_dma_overflow, g_dma_underflow, ofdt, ufdt, dma_dt);
		}


		if(use_joystickbutton == _TRUE){
				// for debug
				// Try push joystick button.
				//
			static int prev1 = 0x10;
			static int prev2 = 0x20;
			int curr1;
			int curr2;
			static int pf = 0;

			if(mode == VSYNC){
				curr1 = inportb(0x201) & 0x10;
				curr2 = inportb(0x201) & 0x20;
				if(prev1 != 0 && curr1 == 0) vga_vsync();
				if(prev2 != 0 && curr2 == 0) samples_this_frame += w_get_current_req();
				prev1 = curr1;
				prev2 = curr2;
			}else{
				curr1 = inportb(0x201) & 0x10;
				curr2 = inportb(0x201) & 0x20;
				if(prev1 != 0 && curr1 == 0){
					pf = (pf + 4) & 0x3F;
					w_set_watermark(2.2, actual_sample_rate / (FRAMES_PER_SEC + pf));
				}
				if(prev2 != 0 && curr2 == 0){
					pf = (pf - 4) & 0x3F;
					w_set_watermark(2.2, actual_sample_rate / (FRAMES_PER_SEC + pf));
				}
				prev1 = curr1;
				prev2 = curr2;
			}
		}

		if( kbhit() ) break;
	}

	w_sound_device_exit();

	return 0;
}


#endif



#if 0


ĂȂɁH

  MAMEp̃TEho̓[`łDȂ̂ŁCt[ɁCႦ1/60bԊuŁC
󋵂݂̂lĂ܂D
  DMACSBCWSS, ESS֐ݒ肷R[h Allegro 炢Ă܂D


Tv

  FIFOobt@܂D
  ̃obt@ɂx̗ʂ̃Tvf[^܂D
  obt@̃Tvf[^񂾂ƍĐCĂ܂D
  obt@Tvf[^ȂȂOɕ[܂D
  D




  ܂CfoCX܂D

int w_sound_device_init(int device_no, int rate_no);

  rate_no ͍ĐgłDʏ 10000Hz ` 64000Hz 炢łD
  ۂɂ͊efoCX󂯕tCɋ߂gݒ肳܂D
  0Ԃ Eternal Silence ͗OŁCw肳ꂽĝ܂܂g܂D
  łC0ԂƉ͖܂̂ŁCʂłȂׂlɂ܂傤D

  device_no ȉɎ܂D

	0. Eternal Silence
	1. Sound Blaster
	4. Ultrasound Max
	5. Ultrasound
	6. Windows Sound System
	7. Ensoniq Soundscape
	8. ESS Audiodrive

	12. Sound Blaster 2.01
	13. Sound Blaster Pro
	14. Sound Blaster 16
	15. Sound Blaster Pro (ex_freq)
	16. Sound Blaster 16  (ex_freq)
	17. CMI8338/8738 as SB16 (DOS Box & Native Dos)
	18. ES1370 AudioPCI as Soundscape (DOS Box & Native Dos)
	19. EV1935 MachOne as SBPro (DOS Box only)
	20. EV1935 MachOne as WSS	(DOS Box only)
	21. Trident 4DWave DX/NX as SB16 (DOS Box & Native Dos)


  ɁCۂ̍Đg𑪒肵܂D

DWORD w_get_actual_sample_rate(void);

  22050Hz Ȃ 22050 ԂĂ܂D



  obt@ɃTvf[^ǂꂮ炢߂ĂCw肵܂D

void w_set_watermark(float latency, DWORD samples_per_frame);

  samples_per_frame ͂Pt[̃Tvf[^ɂł邾߂l
w肵܂D
  b60t[ōĐg22050HzȂ 22050 / 60 = 367 w肵܂D
  ߂ĂTv͒ʏC2t[ƂƂƁC炢ǂ
v܂̂ŁClatency  2.2 xɂ܂D
  samples_per_frame * latency ̒lobt@ɒ߂ĂTv
ɂȂ܂D
  latencỷ1.1炢łD


  Cis^C~O vsync() ŎȂC

float w_calc_samples_per_vsync(void (*__vsync)(void), int vsync_count);

  Ăт܂D
  vsync ֐̃AhXƁC1̃EFCgɂ vsync() ҂̂
w肵܂D
  ʏ vsync_count  1 łCvsync60Hz30FPS
ƂȂǂ 2 w肵܂D



ȉ̓[vł̓łD
60FPSC48000HzƂ܂D


  obt@̃Tvf[^sĂȂׂ܂D

int w_get_watermark_status(void);

  obt@ςȂ 2
  w_set_watermark() Ŏw肵葽Tvf[^obt@ɎcĂ 1
  1t[̃Tv葽 0
  ͏ȂC܂sĂȂ -1
  łɐsĂ -2
  ԂĂ܂D


  CłɐsĂȂ

void w_reset_watermark(void);

  Ă΂Ȃ΂Ȃ܂D


  48000 / 60 = 800 ̃Tvf[^𐶐܂D

  ~LVOobt@pӂ܂D

void w_lock_mixing_buffer(int currentsamplecount);

  currentsamplecount Ŏw肳ꂽ̃~LVOobt@pӂ܂D
  800 w肵܂D
   0 w肵ꍇ́Cw_set_watermark() Ŏw肵1t[
  TvɁClg܂DvɁu܂vłD


  Tvf[^~LVOobt@ɏ݂܂D

void w_mixing(short data[], DWORD length, int leftvol, int rightvol);
void w_mixing_stereo(short data[], DWORD length, int leftvol, int rightvol);

  f[^͕t16bitCXeȈLRłD
  leftvolCrightvol 0 ` 256 łD
  length̓TvłDXeȈꍇLR1TvłD

  Tvf[^̒ƁC~LVOobt@̒قȂꍇC
  Tvf[^̓~LVOobt@̒ɈL΂ꂽ
  k߂ꂽ肵܂D


  FIFOobt@Ƀ~LVOobt@̃Tvf[^ǉ܂D

void w_unlock_mixing_buffer(void);



  vsync()Ń^C~OȂC

DWORD w_get_next_req(void);

  ŁCFIFOobt@ɒǉȂ΂ȂȂTv擾܂D


  ^C~O܂D

  FIFOobt@̌Ń^C~OȂCw_get_watermark_status() 
  -1  0 Ԃ܂ő҂܂D

  vsync()Ń^C~OȂCvsync() ̒

DWORD w_adjust_latency_for_vsync(void);

  Ă΂Ȃ΂Ȃ܂D


[vID





#endif
